//--------------------------------------------------------------------//
// }`{fB_Ci~NX

var model;		// ̌nf[^f
var viewModel;		// \f
var bounds;		// fE
var timeView;		// ԕ\
var time,dt;		// Eԍݕ
var step;		// ^CXebv
var running;		// vZsXCb`
var viewConfig;		// f\ݒ
var modalWindow;	// [_EBhE
var material;		// f\}eA

var FILE_WINDOW=0;	// t@CEBhE
var CONFIG_WINDOW=1;	// RtBOEBhE

// f[^
// fileName - f[^t@C
function initModel(fileName){
  model=new MbdDataModel();
  time=0;
  dt=1;
  step=0;
  running=false;
  document.addEventListener('keydown',keyPressed,false);
  bounds=new Bounds();
  initThree();
  viewConfig=new ViewConfig();
  if((fileName!==null) && (fileName!==undefined)){
    readServerFile(fileName);
  }
  modalWindow=[document.getElementById('file'),
      	       document.getElementById('config')];
  loop();
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 65:		// A
    case 88:		// X
    case 96:		// Numpad0 On
      viewModel.viewX();
      break;
    case 89:		// Y
      viewModel.viewY();
      break;
    case 90:		// Z
      viewModel.viewZ();
      break;
  }
}

// three.js ̏
function initThree(){
  viewModel=new ViewModel('mbd-canvas');
  timeView=document.getElementById('time-canvas');
  timeView.style.color='#ffffff';
  timeView.style.backgroundColor='#000000';
  showTime();
  material=new THREE.MeshStandardMaterial
    ({color:0xcacccc,roughness:0.3,metalness:0.4});
}

// \IuWFNg
function initObject(){
  if(model.bodies.length===0) return;
  for(var i=0;i<model.bodies.length;i++){
    model.bodies[i].setMesh(material);
  }
  bounds.set();
  for(i=0;i<model.bodies.length;i++){
    viewModel.addObject(model.bodies[i].mesh);
  }
  viewModel.setAxis();
  viewModel.updateLightAndCamera();
}

// \IuWFNg
function removeObjects(){
  for(var i=0;i<model.bodies.length;i++){
    var body=model.bodies[i],mesh=body.mesh;
    viewModel.removeObject(mesh);
    mesh.geometry.dispose();
    mesh.material.dispose();
    body.mesh=null;
  }
}

// [v֐
function loop(){
  viewModel.update();
  if(running){
    showTime();
    model.next();
    updateObject();
  }
  requestAnimationFrame(loop);
}

// \
function showTime(){
  timeView.textContent='Time = '+numString(time);
}

// \IuWFNgXV
function updateObject(){
  for(var i=0;i<model.bodies.length;i++){
    model.bodies[i].setMeshPosition();
  }
}

// vZJn
function calcStart(){
  running=true;
}

// vZ𒆒f
function calcStop(){
  running=false;
}

// vZԂɖ߂
function calcInit(){
  running=false;
  model.initPosition();
  updateObject();
  showTime();
}

// f[^Ԃ
// body - Ώە
// te - I
function timeHistory(body,te){
  var s=[];
  model.initPosition();
  s.push('time\tx\ty\tz\tp0\tp1\tp2\tp3');
  while(time<te){
    model.next();
    s.push(time+'\t'+body.p.toString());
  }
  model.initPosition();
  updateObject();
  showTime();
  return s;
}

// `_}gbNXԂ
// p - 3xNg
function tilde(p){
  return new THREE.Matrix3().set(0,-p.z,p.y,p.z,0,-p.x,
      	      	      	      	 -p.y,p.x,0);
}

// WϊsԂ
// p - IC[p[^iNH[^jIj
function conversionMatrix(p){
  var pww=p.w*p.w;
  return new THREE.Matrix3().set(2*(pww+p.x*p.x)-1,
      	      	      	      	 2*(p.x*p.y-p.w*p.z),
      	      	      	      	 2*(p.x*p.z+p.w*p.y),
      	      	      	      	 2*(p.x*p.y+p.w*p.z),
      	      	      	      	 2*(pww+p.y*p.y)-1,
      	      	      	      	 2*(p.y*p.z-p.w*p.x),
      	      	      	      	 2*(p.x*p.z-p.w*p.y),
      	      	      	      	 2*(p.y*p.z+p.w*p.x),
      	      	      	      	 2*(pww+p.z*p.z)-1);
}

// IC[p[^̕s E Ԃ
// p - IC[p[^iNH[^jIj
function matrixE(p){
  return [[-p.x,p.w,-p.z,p.y],
      	  [-p.y,p.z,p.w,-p.x],
      	  [-p.z,-p.y,p.x,p.w]];
}

// IC[p[^̕s L Ԃ
// p - IC[p[^iNH[^jIj
function matrixL(p){
  return [[-p.x,p.w,p.z,-p.y],
      	  [-p.y,-p.z,p.w,p.x],
      	  [-p.z,p.y,-p.x,p.w]];
}

// Matrix3̘aԂ
// m1,m2 - s
function add(m1,m2){
  var e1=m1.elements;
  var e2=m2.elements;
  return new THREE.Matrix3().set(e1[0]+e2[0],e1[3]+e2[3],e1[6]+e2[6],
      	      	      	      	 e1[1]+e2[1],e1[4]+e2[4],e1[7]+e2[7],
      	      	      	      	 e1[2]+e2[2],e1[5]+e2[5],e1[8]+e2[8]);
}

// Matrix3̐ςԂ
// m1,m2 - |킹s
function mul2(m1,m2){
  var e1=m1.elements;
  var e2=m2.elements;
  return new THREE.Matrix3().set(e1[0]*e2[0]+e1[3]*e2[1]+e1[6]*e2[2],
      	      	      	      	 e1[0]*e2[3]+e1[3]*e2[4]+e1[6]*e2[5],
      	      	      	      	 e1[0]*e2[6]+e1[3]*e2[7]+e1[6]*e2[8],
      	      	      	      	 e1[1]*e2[0]+e1[4]*e2[1]+e1[7]*e2[2],
      	      	      	      	 e1[1]*e2[3]+e1[4]*e2[4]+e1[7]*e2[5],
      	      	      	      	 e1[1]*e2[6]+e1[4]*e2[7]+e1[7]*e2[8],
      	      	      	      	 e1[2]*e2[0]+e1[5]*e2[1]+e1[8]*e2[2],
      	      	      	      	 e1[2]*e2[3]+e1[5]*e2[4]+e1[8]*e2[5],
      	      	      	      	 e1[2]*e2[6]+e1[5]*e2[7]+e1[8]*e2[8]);
}

// Matrix3̐ςԂ
// m1,m2,m3 - |킹s
function mul3(m1,m2,m3){
  return mul2(m1,mul2(m2,m3));
}

// ]usƍs̐ m1Tm2 Ԃ
// m1 - ]uĊ|킹s
// m2 - |킹s
function mult(m1,m2){
  var e1=m1.elements;
  var e2=m2.elements;
  return new THREE.Matrix3().set(e1[0]*e2[0]+e1[1]*e2[1]+e1[2]*e2[2],
      	      	      	      	 e1[0]*e2[3]+e1[1]*e2[4]+e1[2]*e2[5],
      	      	      	      	 e1[0]*e2[6]+e1[1]*e2[7]+e1[2]*e2[8],
      	      	      	      	 e1[3]*e2[0]+e1[4]*e2[1]+e1[5]*e2[2],
      	      	      	      	 e1[3]*e2[3]+e1[4]*e2[4]+e1[5]*e2[5],
      	      	      	      	 e1[3]*e2[6]+e1[4]*e2[7]+e1[5]*e2[8],
      	      	      	      	 e1[6]*e2[0]+e1[7]*e2[1]+e1[8]*e2[2],
      	      	      	      	 e1[6]*e2[3]+e1[7]*e2[4]+e1[8]*e2[5],
      	      	      	      	 e1[6]*e2[6]+e1[7]*e2[7]+e1[8]*e2[8]);
}

// sƃxNg̐AbԂ
// a,b - sA,xNgb
function mulmv2(a,b){
  return b.clone().applyMatrix3(a);
}

// sƃxNg̐A1A2bԂ
// a1,a2,b - sA1,A2,xNgb
function mulmv3(a1,a2,b){
  return b.clone().applyMatrix3(a2).applyMatrix3(a1);
}

// l\Ԃ
// value - l
function numString(value){
  var vabs=Math.abs(value);
  if(vabs>=1.0E5){
    return value.toExponential(4);
  }
  else if((vabs>=1) || (vabs===0)){
    return value.toFixed(3);
  }
  else if(vabs>=0.01){
    return value.toFixed(4);
  }
  else{
    return value.toExponential(4);
  }
}

// [_EBhE\
// win - [_EBhẼCfbNX
function showModalWindow(win){
  modalWindow[win].style.zIndex=4;
  modalWindow[win].style.opacity=1;
}

// [_EBhE\ɂ
// win - [_EBhẼCfbNX
function hideModalWindow(win){
  modalWindow[win].style.zIndex=1;
  modalWindow[win].style.opacity=0;
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}

//--------------------------------------------------------------------//
// t@Cǂݍ

var TO_RADIAN=Math.PI/180;	// pxWAɕϊW

// ̌nf[^ft@Cǂݍ
// fileName - f[^t@C
function readServerFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) ||
       (xhr.status===200))){
      try{
      	readModelData(xhr.responseText.split(/\r?\n/g));
      }
      catch(ex){
      	alert(ex);
      }
    }
  };
  xhr.send(null);
}

// [Jt@Cǂݍ
function readLocalFile() {
  var file=document.getElementById('localreadfile').files[0];
  if((file===null) || (file===undefined)){
    alert('t@Cw肳Ă܂');
    return;
  }
  var reader=new FileReader();
  reader.readAsText(file);
  reader.onload=function(e){
    try{
      readModelData(reader.result.split(/\r?\n/g));
    }
    catch(ex){
      alert(ex);
    }
  };
  hideModalWindow(FILE_WINDOW);
}

// [Jt@C
function writeLocalFile() {
  var file=document.getElementById('localwritefile').value.trim();
  if(file===''){
    alert('t@C󔒂ł');
    return;
  }
  var bd=parseInt(document.getElementById('selectbody').value);
  var te=parseFloat(document.getElementById('endtime').value);
  var s=timeHistory(model.bodies[bd],te).join('\n')+'\n';
  var blob=new Blob([s],{type:'text/plain'});
  if(window.navigator.msSaveBlob){		// IEp
    window.navigator.msSaveBlob(blob,file);
  }
  else{						// ̑̃uEU
    var a=document.createElement('a');
    a.href=URL.createObjectURL(blob);
    a.target='_blank';
    a.download=file;
    a.click();
  }
  hideModalWindow(FILE_WINDOW);
}

// ̌nf[^fǂݍ
// s - f[^̃Xg
function readModelData(s){
  removeObjects();
  model.clear();
  var alpha=0;
  var beta=0;
  var row=0;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>0){
      var keyWord=ss[0].toLowerCase();
      if((keyWord=='dt') && (ss.length>1)){
      	dt=parseFloat(ss[1]);
      }
      else if((keyWord=='baumgarte') && (ss.length>2)){
      	alpha=parseFloat(ss[1]);
      	beta=parseFloat(ss[2]);
      }
      else if((keyWord=='box') && (ss.length>5)){
      	var box=new Box(parseInt(ss[1]),parseFloat(ss[2]),
      	      	      	parseFloat(ss[3]),parseFloat(ss[4]),
      	      	      	parseFloat(ss[5]));
      	row++;
      	ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	setPosition(box.p,ss);
      	model.bodies.push(box);
      }
      else if((keyWord=='cylinder') && (ss.length>5)){
      	var cyl=new Cylinder(parseInt(ss[1]),parseFloat(ss[2]),
      	      	      	     parseFloat(ss[3]),parseFloat(ss[4]),
      	      	      	     parseFloat(ss[5]));
      	row++;
      	ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	setPosition(cyl.p,ss);
      	model.bodies.push(cyl);
      }
      else if((keyWord=='sphere') && (ss.length>4)){
      	var sph=new Sphere(parseInt(ss[1]),parseFloat(ss[2]),
      	      	      	   parseFloat(ss[3]),parseFloat(ss[4]));
      	row++;
      	ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	setPosition(sph.p,ss);
      	model.bodies.push(sph);
      }
      else if((keyWord=='balljoint') && (ss.length>8)){
      	var bj=new BallJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	     new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	       parseFloat(ss[4]),
      	      	      	      	      	       parseFloat(ss[5])),
      	      	      	     new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	       parseFloat(ss[7]),
      	      	      	      	      	       parseFloat(ss[8])));
      	model.rigids.push(bj);
      }
      else if((keyWord=='universaljoint') && (ss.length>8)){
      	var uj=new UniversalJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	      	  new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	      	    parseFloat(ss[4]),
      	      	      	      	      	      	    parseFloat(ss[5])),
      	      	      	      	  new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	      	    parseFloat(ss[7]),
      	      	      	      	      	      	    parseFloat(ss[8])));
      	model.rigids.push(uj);
      }
      else if((keyWord=='rotatejoint') && (ss.length>8)){
      	var rj=new RotateJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	       new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	      	 parseFloat(ss[4]),
      	      	      	      	      	      	 parseFloat(ss[5])),
      	      	      	       new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	      	 parseFloat(ss[7]),
      	      	      	      	      	      	 parseFloat(ss[8])));
      	model.rigids.push(rj);
      }
      else if((keyWord=='cylinderjoint') && (ss.length>9)){
      	var cj=new CylinderJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	      	 new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	      	   parseFloat(ss[4]),
      	      	      	      	      	      	   parseFloat(ss[5])),
      	      	      	      	 new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	      	   parseFloat(ss[7]),
      	      	      	      	      	      	   parseFloat(ss[8])),
      	      	      	      	 parseFloat(ss[9]));
      	model.rigids.push(cj);
      }
      else if((keyWord=='slider') && (ss.length>9)){
      	var sl=new Slider(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	  new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	    parseFloat(ss[4]),
      	      	      	      	      	    parseFloat(ss[5])),
      	      	      	  new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	    parseFloat(ss[7]),
      	      	      	      	      	    parseFloat(ss[8])),
      	      	      	  parseFloat(ss[9]));
      	model.rigids.push(sl);
      }
      else if((keyWord=='spring') && (ss.length>10)){
      	var sp=new Spring(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	  new THREE.Vector3(parseFloat(ss[5]),
      	      	      	      	      	    parseFloat(ss[6]),
      	      	      	      	      	    parseFloat(ss[7])),
      	      	      	  new THREE.Vector3(parseFloat(ss[8]),
      	      	      	      	      	    parseFloat(ss[9]),
      	      	      	      	      	    parseFloat(ss[10])),
      	      	      	  parseFloat(ss[3]),parseFloat(ss[4]));
      	model.springs.push(sp);
      }
      else if((keyWord=='gravity') && (ss.length>3)){
      	model.g.set(parseFloat(ss[1]),parseFloat(ss[2]),
      	      	    parseFloat(ss[3]));
      }
    }
    row++;
  }
  if((alpha>0) && (beta>0)) model.setBaumgarte(alpha,beta);
  model.init();
  initObject();
}

// ʒuiWϊjݒ肷
// p - ʒu
// ss - f[^
function setPosition(p,ss){
  setPosition2(p,ss[0].toLowerCase(),TO_RADIAN*parseFloat(ss[1]),
      	       TO_RADIAN*parseFloat(ss[2]),TO_RADIAN*parseFloat(ss[3]),
      	       TO_RADIAN*parseFloat(ss[4]),TO_RADIAN*parseFloat(ss[5]),
      	       TO_RADIAN*parseFloat(ss[6]));
}

// ʒuiWϊjݒ肷
// p - ʒu
// type - px̎
// th1,th2,th3 - ̉]p
// dth1,dth2,dth3 - ]p̎Ԕ
function setPosition2(p,type,th1,th2,th3,dth1,dth2,dth3){
  var c2=Math.cos(th2);
  var c3=Math.cos(th3);
  var s2=Math.sin(th2);
  var s3=Math.sin(th3);
  if(type=='euler'){
    var c1=Math.cos(th1);
    var s1=Math.sin(th1);
    setPositionFromRotate(p,c1*c3-s1*c2*s3,s1*c3+c1*c2*s3,s2*s3,
      	      	      	  -c1*s3-s1*c2*c3,-s1*s3+c1*c2*c3,s2*c3,
      	      	      	  s1*s2,-c1*s2,c2);
    p.w.set(s2*s3*dth1+c3*dth2,s2*c3*dth1-s3*dth2,c2*dth1+dth3);
  }
  else if(type=='taitbryan'){
    p.p.setFromEuler(new THREE.Euler(th1,th2,th3,'ZYX'));
    p.w.set(-s2*dth1+dth3,c2*s3*dth1+c3*dth2,c2*c3*dth1-s3*dth2);
  }
  else if(type=='bryant'){
    p.p.setFromEuler(new THREE.Euler(th1,th2,th3));
    p.w.set(c2*c3*dth1+s3*dth2,-c2*s3*dth1+c3*dth2,s2*dth1+dth3);
  }
}

// ]s񂩂ʒuݒ肷
// p - ʒu
// r11,r12,r13,r21,r22,r23,r31,r32,r33 - ]s̐
function setPositionFromRotate(p,r11,r12,r13,r21,r22,r23,r31,r32,r33){
  var trr=r11+r22+r33;
  var x,y,z,w=0.5*Math.sqrt(trr+1);
  if(w>0){
    x=0.25*(r23-r32)/w;
    y=0.25*(r31-r13)/w;
    z=0.25*(r12-r21)/w;
  }
  else{
    x=0.5*Math.sqrt(2+2*r11);
    if(x>0){
      y=0.5*r12/x;
      z=0.5*r13/x;
    }
    else{
      y=0.5*Math.sqrt(2+2*r22);
      if(y>0){
      	z=0.5*r23/y;
      }
      else{
      	z=1;
      }
    }
  }
  p.p.set(x,y,z,w);
}

// IvVvf쐬
// text - IvṼeLXg
// value - IvV̒l
function createOption(text,value){
  var opt=document.createElement('option');
  opt.value=value;
  opt.text=text;
  return opt;
}

// R{{bNX̃IvV폜
// sel - R{{bNX
function removeOptions(sel){
  if(sel.hasChildNodes()){
    while(sel.childNodes.length>0){
      sel.removeChild(sel.firstChild);
    }
  }
}

// t@CEBhE\
function showFileWindow(){
  calcStop();
  var bodies=document.getElementById('selectbody');
  removeOptions(bodies);
  for(var i=0;i<model.bodies.length;i++){
    bodies.appendChild(createOption(model.bodies[i].getName(),i));
  }
  showModalWindow(FILE_WINDOW);
}

// t@C
function cancelFile(){
  hideModalWindow(FILE_WINDOW);
// t@CI
  var localfile=document.getElementById('localreadfile');
  localfile.parentNode.innerHTML=localfile.parentNode.innerHTML;
}

var C1=[1.0/6.0,1.0/3.0,1.0/3.0,1.0/6.0];	// Runge - Kutta@̌W1
var C2=[0.5,0.5,1.0];				// Runge - Kutta@̌W2

//--------------------------------------------------------------------//
// ̌nf[^f
var MbdDataModel=function(){
  this.bodies=[];		// ̃Xg
  this.rigids=[];		// SXg
  this.springs=[];		// _SXg
  this.tempPos=[];		// Runge-Kutta@Xebṽf[^
  this.g=new THREE.Vector3(0,0,-9.80665);	// d͉xxNg
  this.matrix=[];		// ʁES}gbNX
  this.vector=[];		// ׏dxNg
  this.size=0;			// }gbNXExNg̃TCY
};

// f[^
MbdDataModel.prototype.clear=function(){
  this.bodies.length=0;
  this.rigids.length=0;
  this.springs.length=0;
  this.tempPos.length=0;
  this.matrix.length=0;
  this.vector.length=0;
  this.size=0;
};

// oEKë艻p[^ݒ肷
// alpha,beta - oEKë艻p[^,
MbdDataModel.prototype.setBaumgarte=function(alpha,beta){
  for(var i=0;i<this.rigids.length;i++){
    this.rigids[i].setBaumgarte(alpha,beta);
  }
};

// f
MbdDataModel.prototype.init=function(){
  this.bodies.sort(function(b1,b2){
    if(b1.label<b2.label)      return -1;
    else if(b1.label>b2.label) return 1;
    else                       return 0;
  });
  this.reNumbering();
  this.rigids.sort(compareConstraints);
  this.springs.sort(compareConstraints);
  this.setSize();
  this.setTempPosition1();
  this.setGcPosition();
  this.setInitPosition();
  this.setGravity();
};

// ߓ_|C^ݒ肷
MbdDataModel.prototype.reNumbering=function(){
  var labelMap=[],p1,p2;	// javascript̔z̎̂͘Azz
  for(var i=0;i<this.bodies.length;i++){
    labelMap[this.bodies[i].label]=i;
  }
  for(i=0;i<this.rigids.length;i++){
    p1=this.rigids[i].p1;
    p2=this.rigids[i].p2;
    if(p1 in labelMap) p1=labelMap[p1];
    if(p2 in labelMap) p2=labelMap[p2];
    this.rigids[i].setPosition(p1,p2);
  }
  for(i=0;i<this.springs.length;i++){
    p1=this.springs[i].p1;
    p2=this.springs[i].p2;
    if(p1 in labelMap) p1=labelMap[p1];
    if(p2 in labelMap) p2=labelMap[p2];
    this.springs[i].setPosition(p1,p2);
  }
};

// }gbNXExNg̃TCYݒ肷
MbdDataModel.prototype.setSize=function(){
  this.size=6*this.bodies.length;
  for(var i=0;i<this.rigids.length;i++){
    this.size+=this.rigids[i].dof;
  }
  this.matrix=numeric.rep([this.size,this.size],0.0);
  this.vector=numeric.rep([this.size],0.0);
};

// Runge-Kutta@Xebṽf[^ݒ肷
MbdDataModel.prototype.setTempPosition1=function(){
  for(var i=0;i<this.bodies.length;i++){
    this.tempPos[i]=[this.bodies[i].p,null,null,null];
  }
};

// dSʒuExݒ肷
MbdDataModel.prototype.setGcPosition=function(){
  for(var i=0;i<this.rigids.length;i++){
    var rigid=this.rigids[i];
    rigid.setGcPosition(this.getPosition(rigid.p1,0),
      	      	      	this.getPosition(rigid.p2,0));
  }
};

// ʒuݒ肷
MbdDataModel.prototype.setInitPosition=function(){
  for(var i=0;i<this.bodies.length;i++){
    this.bodies[i].setInitPosition();
  }
};

// ̂ɉd͂vZ
MbdDataModel.prototype.setGravity=function(){
  for(var i=0;i<this.bodies.length;i++){
    var mass=this.bodies[i].mass;
    this.bodies[i].mg.set(mass*this.g.x,mass*this.g.y,mass*this.g.z);
  }
};

// ʒuԂɖ߂
MbdDataModel.prototype.initPosition=function(){
  time=0;
  step=0;
  for(var i=0;i<this.bodies.length;i++){
    this.bodies[i].initPosition();
  }
  this.setTempPosition1();
  this.setGcPosition();
};

// ̃XebvvZ
MbdDataModel.prototype.next=function(){
  time+=dt;
  step++;
  for(var i=0;i<4;i++){
    this.setTempPosition2(i);
    this.createMatrixVector(i);
    this.setAcc(numeric.solve(this.matrix,this.vector),i);
  }
  this.update();
};

// Runge-Kutta@Xebṽf[^ݒ肷
// dt - ԍݕ
// step - Runge-Kutta@̃Xebv
MbdDataModel.prototype.setTempPosition2=function(step){
  if(step===0) return;
  var cdt=dt*C2[step-1];
  for(var i=0;i<this.bodies.length;i++){
    var tp=this.tempPos[i],pre=tp[step-1];
    tp[step]=this.bodies[i].p.clone();
    tp[step].update2(cdt,pre.v,pre.a,pre.eulerVel(),pre.dw);
  }
};

// ʁES}gbNXщ׏dxNg쐬
// step - Runge-Kutta@̃Xebv
MbdDataModel.prototype.createMatrixVector=function(step){
  var ii=0,i1,j1,j0,dof,m,f,mati,mi;
  for(var i=0;i<this.size;i++){
    mati=this.matrix[i];
    for(var j=0;j<this.size;j++){
      mati[j]=0;
    }
    this.vector[i]=0;
  }
  for(i=0;i<this.bodies.length;i++){
    var body=this.bodies[i];
    m=body.massMatrix();
    f=body.forceVector(body.mg,new THREE.Vector3(),
      	      	       this.getPosition(i,step));
    for(i1=0;i1<6;i1++){
      mati=this.matrix[ii+i1];
      mi=m[i1];
      for(j1=0;j1<6;j1++){
      	mati[ii+j1]=mi[j1];
      }
      this.vector[ii+i1]=f[i1];
    }
    ii+=6;
  }
  for(i=0;i<this.rigids.length;i++){
    var rigid=this.rigids[i];
    dof=rigid.dof;
    rigid.create(this.getPosition(rigid.p1,step),
      	      	 this.getPosition(rigid.p2,step));
    f=rigid.vector;
    if(rigid.p1>=0){
      m=rigid.matrix[0];
      j0=6*rigid.p1;
      for(i1=0;i1<dof;i1++){
      	mati=this.matrix[ii+i1];
      	mi=m[i1];
      	for(j1=0;j1<6;j1++){
      	  mati[j0+j1]=mi[j1];
      	  this.matrix[j0+j1][ii+i1]=mi[j1];
      	}
      }
    }
    if(rigid.p2>=0){
      m=rigid.matrix[1];
      j0=6*rigid.p2;
      for(i1=0;i1<dof;i1++){
      	mati=this.matrix[ii+i1];
      	mi=m[i1];
      	for(j1=0;j1<6;j1++){
      	  mati[j0+j1]=mi[j1];
      	  this.matrix[j0+j1][ii+i1]=mi[j1];
      	}
      }
    }
    for(i1=0;i1<dof;i1++){
      this.vector[ii+i1]=f[i1];
    }
    ii+=dof;
  }
  for(i=0;i<this.springs.length;i++){
    var spring=this.springs[i];
    dof=spring.dof;
    spring.create(this.getPosition(spring.p1,step),
      	      	  this.getPosition(spring.p2,step));
    f=spring.vector;
    if(spring.p1>=0){
      j0=6*spring.p1;
      for(i1=0;i1<dof;i1++){
      	this.vector[j0+i1]+=f[i1];
      }
    }
    if(spring.p2>=0){
      j0=6*spring.p2;
      for(i1=0;i1<dof;i1++){
      	this.vector[j0+i1]+=f[dof+i1];
      }
    }
  }
};

// xݒ肷
// a - xxNg
// step - Runge - Kutta@̃Xebv
MbdDataModel.prototype.setAcc=function(a,step){
  var ii=0;
  for(var i=0;i<this.bodies.length;i++){
    this.tempPos[i][step].setAcc(a,ii);
    ii+=6;
  }
};

// f[^XV
// dt - ԍݕ
MbdDataModel.prototype.update=function(){
  var dx=new THREE.Vector3();
  var dv=new THREE.Vector3();
  var dp=[0,0,0,0];
  var dw=new THREE.Vector3();
  var cdt=[dt*C1[0],dt*C1[1],dt*C1[2],dt*C1[3]];
  for(var i=0;i<this.bodies.length;i++){
    dx.set(0,0,0);
    dv.set(0,0,0);
    for(var j=0;j<4;j++) dp[j]=0;
    dw.set(0,0,0);
    for(j=0;j<4;j++){
      var tp=this.tempPos[i][j];
      dx.addScaledVector(tp.v,cdt[j]);
      dv.addScaledVector(tp.a,cdt[j]);
      var ddp=tp.eulerVel();
      for(var k=0;k<4;k++) dp[k]+=0.5*cdt[j]*ddp[k];
      dw.addScaledVector(tp.dw,cdt[j]);
    }
    this.bodies[i].p.update1(dx,dv,dp,dw);
  }
};

// ̈ʒuԂ
// index - ̂̃CfbNX
// step - Runge-Kutta@̃Xebv
MbdDataModel.prototype.getPosition=function(index,step){
  if(index<0) return null;
  else        return this.tempPos[index][step];
};

// S̔r
// c1,c2 - rS
function compareConstraints(c1,c2){
  if(c1.p1<c2.p1)      return -1;
  else if(c1.p1>c2.p1) return 1;
  else if(c1.p2<c2.p2) return -1;
  else if(c1.p2>c2.p2) return 1;
  else                 return 0;
}

//--------------------------------------------------------------------//
// \f
// canvasId - \̈ID
var ViewModel=function(canvasId){
  this.canvasFrame=document.getElementById(canvasId);		// `t[
  this.renderer=new THREE.WebGLRenderer({antialias:true});	// _\
  if(!this.renderer){
    alert("three.js ̏Ɏs܂");
  }

  this.renderer.setSize(this.canvasFrame.clientWidth,
      	      	      	this.canvasFrame.clientHeight);
  this.canvasFrame.appendChild(this.renderer.domElement);

  this.renderer.setClearColor(0x000000,1.0);
  this.scene=new THREE.Scene();					// V[
  this.initLight();
  this.initCamera();
  this.axis=null;
};

// 
ViewModel.prototype.initLight=function(){
// s
  this.directionalLight=new THREE.DirectionalLight(0xffffff,1.0);
  bounds.setLightPosition(this.directionalLight.position);
  this.scene.add(this.directionalLight);
// 
  this.ambientLight=new THREE.AmbientLight(0xcccccc);
  this.scene.add(this.ambientLight);
};

// J
ViewModel.prototype.initCamera=function(){
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size,c=bounds.center;
// J
  this.camera=new THREE.OrthographicCamera
    (-side*aspect,side*aspect,side,-side,
     0.01*bounds.size,100*bounds.size);
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
//  this.camera.lookAt({x:0,y:0,z:0});	Controlsgp͖

// gbN{[Rg[
  this.trackball=new THREE.OrthographicTrackballControls
      	      	   (this.camera,this.canvasFrame);
  this.trackball.screen.width=this.canvasFrame.clientWidth;
  this.trackball.screen.height=this.canvasFrame.clientHeight;
  var bdc=this.canvasFrame.getBoundingClientRect();
  this.trackball.screen.offetLeft=bdc.left;
  this.trackball.screen.offetTop=bdc.top;

  this.trackball.noRotate=false;
  this.trackball.rotateSpeed=4.0;
  this.trackball.noZoom=false;
  this.trackball.zoomSpeed=4.0;
  this.trackball.noPan=false;
  this.trackball.panSpeed=1.0;
  this.trackball.target.copy(c);
  this.trackball.staticMoving=true;
  this.trackball.dynamicDampingFactor=0.3;
};

// \IuWFNgǉ
ViewModel.prototype.addObject=function(obj){
  this.scene.add(obj);
};

// \IuWFNg폜
ViewModel.prototype.removeObject=function(obj){
  this.scene.remove(obj);
};

// Wݒ肷
ViewModel.prototype.setAxis=function(){
  if(this.axis!==null){
    this.scene.remove(this.axis);
    this.axis.geometry.dispose();
    this.axis.material.dispose();
  }
  this.axis=new THREE.AxisHelper(0.2*bounds.size);
  this.axis.position.set(0,0,0);
  this.scene.add(this.axis);
};

// EJʒuXV
ViewModel.prototype.updateLightAndCamera=function(){
  bounds.setLightPosition(this.directionalLight.position);
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size;
  this.camera.left=-side*aspect;
  this.camera.right=side*aspect;
  this.camera.top=side;
  this.camera.bottom=-side;
  this.camera.near=0.01*bounds.size;
  this.camera.far=100*bounds.size;
  this.viewZ();
};

// \XV
ViewModel.prototype.update=function(){
  this.trackball.update();
  this.renderer.render(this.scene,this.camera);
};

// _Xɂ
ViewModel.prototype.viewX=function(){
  var c=bounds.center;
  this.camera.position.set(c.x+bounds.viewPoint,c.y,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Yɂ
ViewModel.prototype.viewY=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y-bounds.viewPoint,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Zɂ
ViewModel.prototype.viewZ=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

//--------------------------------------------------------------------//
// fE
var Bounds=function(){
  this.box=new THREE.Box3();
  this.center=new THREE.Vector3();
  this.size=1;
  this.viewPoint=1;
};

// fEݒ肷
Bounds.prototype.set=function(){
  var group=new THREE.Group();
  for(var i=0;i<model.bodies.length;i++){
    group.add(model.bodies[i].mesh);
  }
  this.box.setFromObject(group);
  this.center.copy(this.box.getCenter());
  this.size=Math.max(this.box.max.x-this.box.min.x,
      	      	     this.box.max.y-this.box.min.y,
      	      	     this.box.max.z-this.box.min.z);
  this.viewPoint=2*this.size;
  for(i=0;i<model.bodies.length;i++){
    group.remove(model.bodies[i].mesh);
  }
};

// ʒuݒ肷
// p - ʒu
Bounds.prototype.setLightPosition=function(p){
  p.set(this.size,-this.size,this.size);
};

//--------------------------------------------------------------------//
// ʒu
var Position=function(){
  this.x=new THREE.Vector3();
  this.v=new THREE.Vector3();
  this.a=new THREE.Vector3();
  this.p=new THREE.Quaternion();
  this.w=new THREE.Vector3();
  this.dw=new THREE.Vector3();
};

// ʒuxNgԂ
// r - ̍Ẅʒu
Position.prototype.vector=function(r){
  return this.x.clone().add(r.clone().applyQuaternion(this.p));
};

// xxNgԂ
// r - ̍Ẅʒu
Position.prototype.velVector=function(r){
  var vl2=mulmv2(tilde(r),this.w).applyQuaternion(this.p);
  return this.v.clone().sub(vl2);
};

// dSʒuExݒ肷
// rl - w_̍̕Wʒu
// xg - w_̑S̍Wʒu
// vg - w_̑x
Position.prototype.setGcPosition=function(rl,xg,vg){
  this.x.subVectors(xg,rl.clone().applyQuaternion(this.p));
  var vv2=mulmv2(tilde(rl),this.w).applyQuaternion(this.p);
  this.v.addVectors(vg,vv2);
};

// ̍WʒuS̍Wɕϊ
// pt - Wʒu
Position.prototype.transPoint=function(pt){
  pt.applyQuaternion(this.p).subVectors(this.x,pt);
};

// IC[p[^̕ωʂ̂Q{ LւԂ
Position.prototype.eulerVel=function(){
  var ll=matrixL(this.p),l0=ll[0],l1=ll[1],l2=ll[2];
  var wx=this.w.x,wy=this.w.y,wz=this.w.z;
  return [l0[0]*wx+l1[0]*wy+l2[0]*wz,l0[1]*wx+l1[1]*wy+l2[1]*wz,
      	  l0[2]*wx+l1[2]*wy+l2[2]*wz,l0[3]*wx+l1[3]*wy+l2[3]*wz];
};

// xݒ肷
// av - xxNg
// i0 - f[^̊JnCfbNX
Position.prototype.setAcc=function(av,i0){
  this.a.fromArray(av,i0);
  this.dw.fromArray(av,i0+3);
};

// f[^XV
// dx - dSʒu̕ω
// dv - x̕ω
// dp - IC[p[^̕ω
// dw - px̕ω
Position.prototype.update1=function(dx,dv,dp,dw){
  this.x.add(dx);
  this.v.add(dv);
  this.p.set(this.p.x+dp[1],this.p.y+dp[2],this.p.z+dp[3],
      	     this.p.w+dp[0]);
  this.p.normalize();
  this.w.add(dw);
};

// f[^XV
// c - W
// dx - dSʒu̕ω
// dv - x̕ω
// dp - IC[p[^̕ω
// dw - px̕ω
Position.prototype.update2=function(c,dx,dv,dp,dw){
  this.x.addScaledVector(dx,c);
  this.v.addScaledVector(dv,c);
  var ch=0.5*c;
  this.p.set(this.p.x+ch*dp[1],this.p.y+ch*dp[2],this.p.z+ch*dp[3],
      	     this.p.w+ch*dp[0]);
  this.p.normalize();
  this.w.addScaledVector(dw,c);
};

// ʒũRs[Ԃ
Position.prototype.clone=function(){
  var pos=new this.constructor();
  pos.x=this.x.clone();
  pos.v=this.v.clone();
  pos.a=this.a.clone();
  pos.p=this.p.clone();
  pos.w=this.w.clone();
  pos.dw=this.dw.clone();
  return pos;
};

// ʒuRs[
// p - QƂʒu
Position.prototype.copy=function(p){
  this.x.copy(p.x);
  this.v.copy(p.v);
  this.a.copy(p.a);
  this.p.copy(p.p);
  this.w.copy(p.w);
  this.dw.copy(p.dw);
};

// ʒu\Ԃ
Position.prototype.toString=function(){
  return this.x.x+'\t'+this.x.y+'\t'+this.x.z+'\t'+this.p.w+'\t'+
      	 this.p.x+'\t'+this.p.y+'\t'+this.p.z;
};

//--------------------------------------------------------------------//
// 
// label - f[^x
var Body=function(label){
  this.label=label;
  this.mass=1;
  this.inertia=new THREE.Matrix3().identity();
  this.p=new Position();
  this.p0=new Position();
  this.mg=new THREE.Vector3();
};

// ʁE[gݒ肷
Body.prototype.setMass=function(mass,ix,iy,iz){
  this.mass=mass;
  this.inertia.set(ix,0,0,0,iy,0,0,0,iz);
};

// 3IuWFNgݒ肷
Body.prototype.setMesh=function(material){
  this.mesh=new THREE.Mesh(this.geometry,material);
  this.mesh.position.copy(this.p.x);
  this.mesh.setRotationFromQuaternion(this.p.p);
};

// 3IuWFNg̈ʒuݒ肷
// org - `ʒu
Body.prototype.setMeshPosition=function(){
  this.mesh.position.copy(this.p.x);
  this.mesh.setRotationFromQuaternion(this.p.p);
};

// ʃ}gbNXԂ
Body.prototype.massMatrix=function(){
  var el=this.inertia.elements;
  return [[this.mass,0,0,0,0,0],
      	  [0,this.mass,0,0,0,0],
      	  [0,0,this.mass,0,0,0],
      	  [0,0,0,el[0],el[3],el[6]],
      	  [0,0,0,el[1],el[4],el[7]],
      	  [0,0,0,el[2],el[5],el[8]]];
};

// ʒuݒ肷
Body.prototype.setInitPosition=function(){
  this.p0.copy(this.p);
};

// ʒuԂɖ߂
Body.prototype.initPosition=function(){
  this.p.copy(this.p0);
};

// ׏dxNgԂ
// f - O
// t - OgN
// p - ʒu
Body.prototype.forceVector=function(f,t,p){
  var jw=mulmv3(tilde(p.w),this.inertia,p.w);
  return [f.x,f.y,f.z,t.x-jw.x,t.y-jw.y,t.z-jw.z];
};

//--------------------------------------------------------------------//
// p
// label - f[^x
// a - x
// b - y
// c - z
// density - x
var Box=function(label,a,b,c,density){
  Body.call(this,label);
  this.geometry=new THREE.BoxGeometry(a,b,c);
  this.density=density;
  this.mass=density*a*b*c;
  var ic=this.mass/12;
  this.inertia.set(ic*(b*b+c*c),0,0,
      	      	   0,ic*(c*c+a*a),0,
      	      	   0,0,ic*(a*a+b*b));
};

// ̖Ԃ
Box.prototype.getName=function(){
  return 'Box'+this.label;
};

//--------------------------------------------------------------------//
// 
// label f[^x
// ro - Oa
// ri - a
// density - x
var Sphere=function(label,ro,ri,density){
  Body.call(this,label);
  this.geometry=new THREE.SphereGeometry(ro);
  this.ri=ri;
  this.density=density;
  var ro3=ro*ro*ro,ri3=ri*ri*ri,mc=4*Math.PI*density/3;
  this.mass=mc*(ro3-ri3);
  var ix=0.4*mc*(ro3*ro*ro-ri3*ri*ri);
  this.inertia.set(ix,0,0,0,ix,0,0,0,ix);
};

// ̖Ԃ
Sphere.prototype.getName=function(){
  return 'Sphere'+this.label;
};

//--------------------------------------------------------------------//
// ~
// label f[^x
// ro - Oa
// ri - a
// l - 
// density - x
var Cylinder=function(label,ro,ri,l,density){
  Body.call(this,label);
  this.geometry=new THREE.CylinderGeometry(ro,ro,l);
  this.geometry.rotateX(0.5*Math.PI);
  this.ri=ri;
  this.density=density;
  this.mass=Math.PI*density*(ro*ro-ri*ri)*l;
  var ix=this.mass*(3*(ro*ro+ri*ri)+l*l)/12;
  this.inertia.set(ix,0,0,0,ix,0,0,
      	      	   0,0.5*this.mass*(ro*ro+ri*ri));
};

// ̖Ԃ
Cylinder.prototype.getName=function(){
  return 'Cylinder'+this.label;
};

inherits(Box,Body);
inherits(Sphere,Body);
inherits(Cylinder,Body);

//--------------------------------------------------------------------//
// S
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var Constraint=function(p1,p2,r1,r2){
  this.p1=p1;
  this.p2=p2;
  this.r1=r1;
  this.r2=r2;
  this.vector=[];
};

// SΏۈʒuݒ肷
// p1,p2 - SΏۈʒũCfbNX
Constraint.prototype.setPosition=function(p1,p2){
  this.p1=p1;
  this.p2=p2;
};

// Sʒuݒ肷
// r1,r2 - SΏە̂̍Sʒu
Constraint.prototype.setCoords=function(r1,r2){
  this.r1=r1;
  this.r2=r2;
};

// SΏە̂PƂQւ
Constraint.prototype.swap=function(){
  var tp=this.p1;
  this.p1=this.p2;
  this.p2=tp;
  var tr=this.r1;
  this.r1=this.r2;
  this.r2=tr;
};

//--------------------------------------------------------------------//
// S
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var RigidConstraint=function(p1,p2,r1,r2){
  Constraint.call(this,p1,p2,r1,r2);
  this.alpha=10;
  this.beta=10;
  this.matrix=[null,null];
};

// oEKë艻p[^ݒ肷
// alpha,beta - oEKë艻p[^,
RigidConstraint.prototype.setBaumgarte=function(alpha,beta){
  this.alpha=alpha;
  this.beta=beta;
};

// dSʒuExݒ肷
// p1,p2 - SΏۈʒu
RigidConstraint.prototype.setGcPosition=function(p1,p2){
  if(p1===null){
    p2.setGcPosition(this.r2,this.r1,new THREE.Vector3());
  }
  else if(p2===null){
    p1.setGcPosition(this.r1,this.r2,new THREE.Vector3());
  }
  else{
    p2.setGcPosition(this.r2,p1.vector(this.r1),p1.velVector(this.r1));
  }
};

// _S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// index - S̊Jns
RigidConstraint.prototype.point=function(p1,p2,index){
  var g1=this.point2(p1,this.r1,index,0);
  var bt2=this.beta*this.beta;
  if(g1===null){
    this.vector[index]+=bt2*this.r1.x;
    this.vector[index+1]+=bt2*this.r1.y;
    this.vector[index+2]+=bt2*this.r1.z;
  }
  else{
    this.vector[index]-=g1.x;
    this.vector[index+1]-=g1.y;
    this.vector[index+2]-=g1.z;
  }
  var g2=this.point2(p2,this.r2,index,1);
  if(g2===null){
    this.vector[index]-=bt2*this.r2.x;
    this.vector[index+1]-=bt2*this.r2.y;
    this.vector[index+2]-=bt2*this.r2.z;
  }
  else{
    this.vector[index]+=g2.x;
    this.vector[index+1]+=g2.y;
    this.vector[index+2]+=g2.z;
  }
};

// _S}gbNXES׏dxNg쐬
// p - SΏۈʒu
// r - Sʒu
// index - S̊Jns
// mi - ̂̃CfbNX
RigidConstraint.prototype.point2=function(p,r,index,mi){
  if((p===null) || (r===null)) return null;
  var rr=conversionMatrix(p.p);
  var rtl=tilde(r);
  var cth=mul2(rr,rtl).multiplyScalar(-1);
  var cf=Number(2*mi-1);
  var mat=this.matrix[mi];
  var cthe=cth.elements;
  for(var i=0;i<3;i++){
    mat[index+i][i]=cf;
    for(var j=0;j<3;j++){
      mat[index+i][3+j]=cf*cthe[i+3*j];
    }
  }
  var gam=mulmv3(tilde(p.w),rtl,p.w).applyMatrix3(rr);
  var v1=new THREE.Vector3().addVectors(p.v,mulmv2(cth,p.w))
      	.multiplyScalar(2*this.alpha);
  var v2=p.vector(r).multiplyScalar(this.beta*this.beta);
  return gam.sub(v1.add(v2));
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// s1,s2 - SΏە̂̈ړ
// index - S̊Jns
RigidConstraint.prototype.axis=function(p1,p2,s1,s2,index){
  var rr1,rr2,w1,w2;
  if(p1===null){
    rr1=new THREE.Matrix3();
    w1=new THREE.Vector3();
  }
  else{
    rr1=conversionMatrix(p1.p);
    w1=p1.w;
  }
  if(p2===null){
    rr2=new THREE.Matrix3();
    w2=new THREE.Vector3();
  }
  else{
    rr2=conversionMatrix(p2.p);
    w2=p2.w;
  }
  var stl1=tilde(s1);
  var stl2=tilde(s2);
  var wtl1=tilde(w1);
  var wtl2=tilde(w2);
  var rrstl1=mul2(rr1,stl1);
  var rrstl2=mul2(rr2,stl2);
  var rr12=mult(rr1,rr2);
  var rr21=rr12.clone().transpose();

  var cth1=mul2(rrstl2,mult(rr2,rrstl1));
  var cth2=mul2(rrstl1,mult(rr1,rrstl2)).multiplyScalar(-1);
  var a1=add(mul2(tilde(mulmv2(wtl2,s2)),rr21),mul3(stl2,rr21,wtl1));
  a1=mul3(rr2,a1,stl1).multiplyScalar(-1);
  var a2=add(mul2(tilde(mulmv2(wtl1,s1)),rr12),mul3(stl1,rr12,wtl2));
  a2=mul3(rr1,a2,stl2);
  var gam=mulmv2(a1,w1).add(mulmv2(a2,w2));
  var v1=mulmv2(cth1,w1).add(mulmv2(cth2,w2))
      	.multiplyScalar(2*this.alpha);
  var v2=mulmv3(rrstl1,rr12,s2).multiplyScalar(this.beta*this.beta);
  gam.sub(v1.add(v2));

  var clist=compList(mulmv2(rr1,s1)),gg=[gam.x,gam.y,gam.z];
  var cthe1=cth1.elements,cthe2=cth2.elements;
  for(var i=0;i<2;i++){
    for(var j=0;j<3;j++){
      this.matrix[0][index+i][j+3]=cthe1[clist[i]+3*j];
      this.matrix[1][index+i][j+3]=cthe2[clist[i]+3*j];
    }
    this.vector[index+i]=gg[clist[i]];
  }
};

// ΈʒuS}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// s - SΏە̂̈ړ
// index - S̊Jns
RigidConstraint.prototype.direction=function(p1,p2,s,index){
  var rr1,rr2,x1,x2,v1,v2,w1,w2;
  if(p1===null){
    rr1=new THREE.Matrix3();
    x1=this.r1.clone();
    v1=new THREE.Vector3();
    w1=new THREE.Vector3();
  }
  else{
    rr1=conversionMatrix(p1.p);
    x1=p1.vector(this.r1);
    v1=p1.v;
    w1=p1.w;
  }
  if(p2===null){
    rr2=new THREE.Matrix3();
    x2=this.r2.clone();
    v2=new THREE.Vector3();
    w2=new THREE.Vector3();
  }
  else{
    rr2=conversionMatrix(p2.p);
    x2=p2.vector(this.r2);
    v2=p2.v;
    w2=p2.w;
  }
  var stl=tilde(s);
  var rtl1=tilde(this.r1);
  var rtl2=tilde(this.r2);
  var wtl1=tilde(w1);
  var wtl2=tilde(w2);
  var rrstl=mul2(rr1,stl);
  var rtr=mul2(rrstl,rr1.clone().transpose());
  var rrwtl1=mul2(rr1,wtl1);

  var d12=x2.sub(x1);
  var cr1=rtr.clone().multiplyScalar(-1);
  var cr2=rtr;
  var cth1=add(mul2(rrstl,rtl1),mul2(tilde(d12),rrstl));
  var cth2=mul3(rtr,rr2,rtl2).multiplyScalar(-1);
  var gam=tilde(v1.clone().sub(v2).multiplyScalar(2));
  gam=mulmv3(gam,rrstl,w1);
  var vv1=mulmv3(rr2,wtl2,this.r2).sub(mulmv2(rrwtl1,this.r1));
  var a1=add(add(mul3(rrwtl1,stl,rtl1),mul2(tilde(vv1),rrstl)),
      	     mul3(tilde(d12),rrwtl1,stl)).multiplyScalar(-1);
  var rr12=mult(rr1,rr2);
  var a2=mul3(rr1,add(mul2(tilde(mulmv2(wtl1,s)),rr12),
      	      	      mul3(stl,rr12,wtl2)),rtl2);
  var v12=mulmv2(a1,w1).add(mulmv2(a2,w2));
  vv1=mulmv2(cr1,v1).add(mulmv2(cr2,v2)).add(mulmv2(cth1,w1))
    .add(mulmv2(cth2,w2)).multiplyScalar(2*this.alpha);
  var vv2=mulmv2(rtr,d12).multiplyScalar(this.beta*this.beta);
  gam.add(v12).sub(vv1.add(vv2));

  var clist=compList(mulmv2(rr1,s)),gg=[gam.x,gam.y,gam.z];
  var cre1=cr1.elements,cre2=cr2.elements;
  var cthe1=cth1.elements,cthe2=cth2.elements;
  for(var i=0;i<2;i++){
    var mat1=this.matrix[0][index+i];
    var mat2=this.matrix[1][index+i];
    for(var j=0;j<3;j++){
      var cl=clist[i]+3*j;
      mat1[j]=cre1[cl];
      mat1[j+3]=cthe1[cl];
      mat2[j]=cre2[cl];
      mat2[j+3]=cthe2[cl];
    }
    this.vector[index+i]=gg[clist[i]];
  }
};

// ]S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// b1x,b2y - SΏە̂̈ړ
// index - S̊Jns
RigidConstraint.prototype.rotate=function(p1,p2,b1x,b2y,index){
  var rr1,rr2,w1,w2;
  if(p1===null){
    rr1=new THREE.Matrix3();
    w1=new THREE.Vector3();
  }
  else{
    rr1=conversionMatrix(p1.p);
    w1=p1.w;
  }
  if(p2===null){
    rr2=new THREE.Matrix3();
    w2=new THREE.Vector3();
  }
  else{
    rr2=conversionMatrix(p2.p);
    w2=p2.w;
  }

  var wtl1=tilde(w1);
  var wtl2=tilde(w2);
  var rr21=mult(rr2,rr1);
  var cth1=mulmv3(tilde(b1x),rr21.clone().transpose(),b2y);
  var cth2=mulmv3(tilde(b2y),rr21,b1x);

  var ga1=add(mul3(rr21,wtl1,wtl1),mul3(wtl2,wtl2,rr21));
  var ga2=mul3(tilde(b2y),rr21,tilde(b1x));
  var gam1=mulmv2(ga1,b1x).dot(b2y);
  var gam2=mulmv2(ga2,w1).dot(w2);
  var gam3=cth1.dot(w1)+cth2.dot(w2);
  var gam4=mulmv2(rr21,b1x).dot(b2y);
  var gam=-gam1+2*gam2-2*this.alpha*gam3-this.beta*this.beta*gam4;
  var mat1=this.matrix[0][index];
  var mat2=this.matrix[1][index];
  mat1[3]=cth1.x;
  mat1[4]=cth1.y;
  mat1[5]=cth1.z;
  mat2[3]=cth2.x;
  mat2[4]=cth2.y;
  mat2[5]=cth2.z;
  this.vector[index]=gam;
};

// xNg̐Ԃ̃XgA
// v - xNg
function compList(v){
  var index=[0,1,2],vv=[Math.abs(v.x),Math.abs(v.y),Math.abs(v.z)],tv;
  if(vv[0]>vv[1]){
    tv=vv[1];
    vv[1]=vv[0];
    vv[0]=tv;
    index[0]=1;
    index[1]=0;
  }
  if(vv[0]>vv[2]){
    tv=vv[2];
    vv[2]=vv[1];
    vv[1]=vv[0];
    vv[0]=tv;
    index[2]=index[1];
    index[1]=index[0];
    index[0]=2;
  }
  else if(vv[1]>vv[2]){
    tv=vv[2];
    vv[2]=vv[1];
    vv[1]=tv;
    index[2]=index[1];
    index[1]=2;
  }
  return index;
}

//--------------------------------------------------------------------//
// WCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var BallJoint=function(p1,p2,r1,r2){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.dof=3;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
BallJoint.prototype.create=function(p1,p2){
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  if(p1!==null) this.matrix[0]=numeric.rep([this.dof,6],0);
  if(p2!==null) this.matrix[1]=numeric.rep([this.dof,6],0);
  this.point(p1,p2,0);
};

//--------------------------------------------------------------------//
// jo[TWCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var UniversalJoint=function(p1,p2,r1,r2){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.dof=4;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.b1x=new THREE.Vector3(1,0,0);
  this.b2y=new THREE.Vector3(0,1,0);
};

// SΏە̂̎ݒ肷
// b1x,b2y - SΏە̂̉]
UniversalJoint.prototype.setAxis=function(b1x,b2y){
  this.b1x=b1x;
  this.b2y=b2y;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
UniversalJoint.prototype.create=function(p1,p2){
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.point(p1,p2,0);
  this.rotate(p1,p2,this.b1x,this.b2y,3);
};

//--------------------------------------------------------------------//
// ]WCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var RotateJoint=function(p1,p2,r1,r2){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.dof=5;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.s1=new THREE.Vector3(0,0,1);
  this.s2=new THREE.Vector3(0,0,1);
};

// SΏە̂̎ݒ肷
// s1,s2 - SΏە̂̈ړ
RotateJoint.prototype.setAxis=function(s1,s2){
  this.s1=s1;
  this.s2=s2;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
RotateJoint.prototype.create=function(p1,p2){
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.point(p1,p2,0);
  this.axis(p1,p2,this.s1,this.s2,3);
};

//--------------------------------------------------------------------//
// ]~WCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
// z0 - ʒu
var CylinderJoint=function(p1,p2,r1,r2,z0){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.z0=z0;
  this.dof=4;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.s1=new THREE.Vector3(0,0,1);
  this.s2=new THREE.Vector3(0,0,1);
};

// SΏە̂̎ݒ肷
// s1,s2 - SΏە̂̈ړ
CylinderJoint.prototype.setAxis=function(s1,s2){
  this.s1=s1;
  this.s2=s2;
};

// dSʒuExݒ肷
// p1,p2 - SΏۈʒu
CylinderJoint.prototype.setGcPosition=function(p1,p2){
  if(p1===null){
    p2.setGcPosition(this.r2,this.r1,new THREE.Vector3());
  }
  else if(p2===null){
    p1.setGcPosition(this.r1,this.r2,new THREE.Vector3());
  }
  else{
    var ri=this.r1.clone().addScaledVector(this.s1,this.z0);
    p2.setGcPosition(this.r2,p1.vector(ri),p1.velVector(ri));
  }
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
CylinderJoint.prototype.create=function(p1,p2){
  this.axis(p1,p2,this.s1,this.s2,0);
  this.direction(p1,p2,this.s1,2);
};

//--------------------------------------------------------------------//
// ]iWCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
// z0 - ʒu
var Slider=function(p1,p2,r1,r2,z0){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.z0=z0;
  this.dof=5;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.s1=new THREE.Vector3(0,0,1);
  this.s2=new THREE.Vector3(0,0,1);
  this.b1x=new THREE.Vector3(1,0,0);
  this.b2x=new THREE.Vector3(1,0,0);
};

// SΏە̂̎ݒ肷
// s1,s2 - SΏە̂̈ړ
// b1x,b2x - SΏە̂̈ړ
Slider.prototype.setAxis=function(s1,s2,b1x,b2x){
  this.s1=s1;
  this.s2=s2;
  this.b1x=b1x;
  this.b2x=b2x;
};

// dSʒuExݒ肷
// p1,p2 - SΏۈʒu
Slider.prototype.setGcPosition=function(p1,p2){
  if(p1===null){
    p2.setGcPosition(this.r2,this.r1,new THREE.Vector3());
  }
  else if(p2===null){
    p1.setGcPosition(this.r1,this.r2,new THREE.Vector3());
  }
  else{
    var ri=this.r1.clone().addScaledVector(this.s1,this.z0);
    p2.setGcPosition(this.r2,p1.vector(ri),p1.velVector(ri));
  }
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
Slider.prototype.create=function(p1,p2){
  var b2y=this.s2.clone().cross(this.b2x).normalize();
  this.axis(p1,p2,this.s1,this.s2,0);
  this.direction(p1,p2,this.s1,2);
  this.rotate(p1,p2,this.b1x,b2y,4);
};

//--------------------------------------------------------------------//
// ΂˗vf
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
// k - ΂˒萔
// l0 - R
var Spring=function(p1,p2,r1,r2,k,l0){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.k=k;
  this.l0=l0;
  this.dof=3;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
Spring.prototype.create=function(p1,p2){
  var f;
  if(p2!==null) f=p2.vector(this.r2);
  else          f=this.r2.clone();
  if(p1!==null) f.sub(p1.vector(this.r1));
  else          f.sub(this.r1);
  var l=f.length();
  if(l!==0) f.multiplyScalar(this.k*(l-this.l0)/l);
  this.vector=[f.x,f.y,f.z,-f.x,-f.y,-f.z];
};

inherits(RigidConstraint,Constraint);
inherits(BallJoint,RigidConstraint);
inherits(UniversalJoint,RigidConstraint);
inherits(RotateJoint,RigidConstraint);
inherits(CylinderJoint,RigidConstraint);
inherits(Slider,RigidConstraint);
inherits(Spring,Constraint);

//--------------------------------------------------------------------//
// f\ݒ
var ViewConfig=function(){
  var canvas=document.getElementById('el-color');	// f\Fݒp
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  this.cpicker=new ColorPicker(canvas);			// J[sbJ[
  this.lightx=document.getElementById('lightx');	// ʒuݒp
  this.lighty=document.getElementById('lighty');
  this.lightz=document.getElementById('lightz');
};

// RtBOEBhE\
ViewConfig.prototype.show=function(){
  var color=material.color;
  this.cpicker.setColor([color.r,color.g,color.b]);
  var lp=viewModel.directionalLight.position;
  this.lightx.value=numString(lp.x);
  this.lighty.value=numString(lp.y);
  this.lightz.value=numString(lp.z);
};

// RtBOݒ肷
ViewConfig.prototype.set=function(){
  var colors=this.cpicker.getColor();
  material.color.setRGB(colors[0],colors[1],colors[2]);
  var lp=viewModel.directionalLight.position;
  lp.set(parseFloat(this.lightx.value),parseFloat(this.lighty.value),
      	 parseFloat(this.lightz.value));
};

// RtBOEBhE\
function showConfig(){
  showModalWindow(CONFIG_WINDOW);
  viewConfig.show();
}

// RtBOݒ肷
function setConfig(){
  hideModalWindow(CONFIG_WINDOW);
  viewConfig.set();
}

// RtBO
function cancelConfig(){
  hideModalWindow(CONFIG_WINDOW);
}

var CPICK_FONT_SIZE=14;				// tHgTCY
var CPICK_FONT=CPICK_FONT_SIZE+"px 'Arial'";	// tHg

//--------------------------------------------------------------------//
// J[sbJ[
// canvas - `LoX
// div - ~``敪
// x,y,width,height - `ʒu,,
var ColorPicker=function(canvas,div,x,y,width,height){
  this.canvas=canvas;
  this.context=canvas.getContext('2d');	// ReLXg
  this.context.font=CPICK_FONT;
  this.context.textBaseline='top';
  this.div=div||360;
  x=x||0;
  y=y||0;
  width=width||canvas.width;
  height=height||canvas.height;
// SW
  var size=Math.min(width,height);
  this.cx=parseInt(x+0.5*size);
  this.cy=parseInt(y+0.5*size);
// F~`XC_[a
  this.ro=parseInt(0.48*size);
  this.rc=parseInt(0.9*this.ro);
  this.ri=parseInt(0.8*this.ro);
// ʓxPx}bv`ʒu,TCY
  this.rect=parseInt(1.3*this.ri);
  this.rx=parseInt(this.cx-0.5*this.rect);
  this.ry=parseInt(this.cy-0.5*this.rect);
  this.pt=parseInt(Math.max(0.07*this.ri,1));
  this.hsl=[0,0,0];			// ݂̐F (HSLF)
// eLXgʒu
  if(width>=height){
    this.tx=size+10;
    this.ty=10;
  }
  else{
    this.tx=10;
    this.ty=size+10;
  }
  this.initMouseEvent();
};

// ݂̐Fݒ肷
// rgb - w肷F (RGB)
ColorPicker.prototype.setColor=function(rgb){
  var r=rgb[0],g=rgb[1],b=rgb[2];
  var rgbmax=Math.max(Math.max(r,g),b);
  var rgbmin=Math.min(Math.min(r,g),b);
  this.hsl[2]=0.5*(rgbmax+rgbmin);
  if(rgbmax===rgbmin){
    this.hsl[0]=0;
    this.hsl[1]=0;
  }
  else{
    var del=rgbmax-rgbmin;
    this.hsl[1]=del/(1-Math.abs(2*this.hsl[2]-1));
    if(rgbmin===b)      this.hsl[0]=((g-r)/del+1)/6;
    else if(rgbmin===r) this.hsl[0]=((b-g)/del+3)/6;
    else if(rgbmin===g) this.hsl[0]=((r-b)/del+5)/6;
  }
  this.draw();
};

// ݂̐F (RGB) Ԃ
ColorPicker.prototype.getColor=function(){
  var h=this.hsl[0],s=this.hsl[1],l=this.hsl[2];
  var rgbmax=l+0.5*s*(1-Math.abs(2*l-1));
  var rgbmin=2*l-rgbmax;
  return [hueToRGB(rgbmax,rgbmin,h+1/3),hueToRGB(rgbmax,rgbmin,h),
      	  hueToRGB(rgbmax,rgbmin,h-1/3)];
};

// J[sbJ[`悷
ColorPicker.prototype.draw=function(){
  this.context.clearRect(0,0,this.canvas.width,this.canvas.height);
// FXC_[
  var dth=2*Math.PI/this.div,dh=360/this.div;
  var cc0=1,ss0=0,th,h,s,l,i;
  for(i=0;i<this.div;i++){
    th=dth*(i+1);
    var cc1=Math.cos(th),ss1=Math.sin(th);
    h=dh*i;
    this.context.fillStyle='hsl('+h+',100%,50%)';
    this.context.strokeStyle=this.context.fillStyle;
    this.context.beginPath();
    this.context.moveTo(this.cx+this.ri*cc0,this.cy-this.ri*ss0);
    this.context.lineTo(this.cx+this.ro*cc0,this.cy-this.ro*ss0);
    this.context.lineTo(this.cx+this.ro*cc1,this.cy-this.ro*ss1);
    this.context.lineTo(this.cx+this.ri*cc1,this.cy-this.ri*ss1);
    this.context.closePath();
    this.context.fill();
    this.context.stroke();
    cc0=cc1;
    ss0=ss1;
  }
  th=2*Math.PI*this.hsl[0];
  cc0=Math.cos(th);
  ss0=Math.sin(th);
  this.drawPointer(this.cx+this.rc*cc0,this.cy-this.rc*ss0);

// ʓxPx}bv
  h=360*this.hsl[0];
  var dl=100/this.rect;
  for(i=0;i<this.rect;i++){
    var y=this.ry+i;
    l=dl*(this.rect-i);
    var grad=this.context.createLinearGradient
      (this.rx,y,this.rx+this.rect,y);
    grad.addColorStop(0,'hsl('+h+',0%,'+l+'%)');
    grad.addColorStop(1,'hsl('+h+',100%,'+l+'%)');
    this.context.fillStyle=grad;
    this.context.fillRect(this.rx,y,this.rect,1);
  }
  this.drawPointer(parseInt(this.rx+this.rect*this.hsl[1]),
      	      	   parseInt(this.ry+this.rect*(1-this.hsl[2])));

// eLXg
  this.context.fillStyle='#000000';
  this.context.fillText('H:'+parseInt(h),this.tx,this.ty);
  s=parseInt(100*this.hsl[1]);
  l=parseInt(100*this.hsl[2]);
  if(this.tx<=this.ty){
    var w=parseInt(this.canvas.width/3);
    this.context.fillText('S:'+s+'%',this.tx+w,this.ty);
    this.context.fillText('L:'+l+'%',this.tx+2*w,this.ty);
  }
  else{
    this.context.fillText('S:'+s+'%',this.tx,this.ty+CPICK_FONT_SIZE);
    this.context.fillText('L:'+l+'%',this.tx,this.ty+2*CPICK_FONT_SIZE);
  }
};

// |C^`悷
// x,y - `ʒu
ColorPicker.prototype.drawPointer=function(x,y){
  var h=360*this.hsl[0],s=100*this.hsl[1],l=100*this.hsl[2];
  this.context.fillStyle='hsl('+h+','+s+'%,'+l+'%)';
  this.context.beginPath();
  this.context.arc(x,y,this.pt,0,2*Math.PI,false);
  this.context.closePath();
  this.context.fill();
  this.context.strokeStyle='#ffffff';
  this.context.beginPath();
  this.context.arc(x,y,this.pt,0,2*Math.PI,false);
  this.context.closePath();
  this.context.stroke();
  this.context.strokeStyle='#000000';
  this.context.beginPath();
  this.context.arc(x,y,this.pt+1,0,2*Math.PI,false);
  this.context.closePath();
  this.context.stroke();
};

// }EXCxg
ColorPicker.prototype.initMouseEvent=function(){
  var mx,my,pressedArea=-1,cp=this;
  this.canvas.addEventListener('mousedown',cpMousePressed,false);

// }EX{^̏s
  function cpMousePressed(e){
    e.preventDefault();
    e.stopPropagation();
    document.addEventListener('mouseup',cpMouseReleased,false);
    document.addEventListener('mousemove',cpMouseMoved,false);
    var bcr=e.target.getBoundingClientRect();
    mx=e.clientX-bcr.left;
    my=e.clientY-bcr.top;
    if((cp.rx-cp.pt<=mx) && (mx<=cp.rx+cp.rect+cp.pt) &&
       (cp.ry-cp.pt<=my) && (my<=cp.ry+cp.rect+cp.pt)){
      pressedArea=1;
      var sl=satLight();
      cp.hsl[1]=sl[0];
      cp.hsl[2]=sl[1];
    }
    else{
      pressedArea=0;
      cp.hsl[0]=hue();
    }
    cp.draw();
  }

// }EX{^𗣂̏s
  function cpMouseReleased(e){
    e.preventDefault();
    e.stopPropagation();
    document.removeEventListener('mouseup',cpMouseReleased,false);
    document.removeEventListener('mousemove',cpMouseMoved,false);
    pressedArea=-1;
  }

// }EX{^ړ̏s
  function cpMouseMoved(e){
    var bcr=e.target.getBoundingClientRect();
    switch(pressedArea){
      case 0:
      	mx=e.clientX-bcr.left;
      	my=e.clientY-bcr.top;
      	cp.hsl[0]=hue();
      	cp.draw();
      	break;
      case 1:
      	mx=e.clientX-bcr.left;
      	my=e.clientY-bcr.top;
      	var sl=satLight();
      	cp.hsl[1]=sl[0];
      	cp.hsl[2]=sl[1];
      	cp.draw();
      	break;
    }
  }

// FԂ
  function hue(){
    var h=Math.atan2(cp.cy-my,mx-cp.cx)/(2*Math.PI);
    if(h<0) h+=1;
    return h;
  }

// ʓxPxԂ
  function satLight(){
    var s=(mx-cp.rx)/cp.rect;
    var l=1-(my-cp.ry)/cp.rect;
    return [Math.min(Math.max(s,0),1),Math.min(Math.max(l,0),1)];
  }
};

// RGBJ[Ԃ
// rgbmax,rgbmin - R,G,B̍ől,ŏl
// h - F
function hueToRGB(rgbmax,rgbmin,h){
  if(h<0)      h+=1;
  else if(h>1) h-=1;
  h*=6;
  if(h<1)       return rgbmin+(rgbmax-rgbmin)*h;
  else if(h<=3) return rgbmax;
  else if(h<4)  return rgbmin+(rgbmax-rgbmin)*(4-h);
  else          return rgbmin;
}
