//--------------------------------------------------------------------//
// 
// label - f[^x
var Body=function(label){
  this.label=label;
  this.mass=1;
  this.inertia=new THREE.Matrix3().identity();
  this.p=new Position();
  this.p0=new Position();
  this.mg=new THREE.Vector3();
};

// ʁE[gݒ肷
Body.prototype.setMass=function(mass,ix,iy,iz){
  this.mass=mass;
  this.inertia.set(ix,0,0,0,iy,0,0,0,iz);
};

// 3IuWFNgݒ肷
Body.prototype.setMesh=function(material){
  this.mesh=new THREE.Mesh(this.geometry,material);
  this.mesh.position.copy(this.p.x);
  this.mesh.setRotationFromQuaternion(this.p.p);
};

// 3IuWFNg̈ʒuݒ肷
// org - `ʒu
Body.prototype.setMeshPosition=function(){
  this.mesh.position.copy(this.p.x);
  this.mesh.setRotationFromQuaternion(this.p.p);
};

// ʃ}gbNXԂ
Body.prototype.massMatrix=function(){
  var el=this.inertia.elements;
  return [[this.mass,0,0,0,0,0],
      	  [0,this.mass,0,0,0,0],
      	  [0,0,this.mass,0,0,0],
      	  [0,0,0,el[0],el[3],el[6]],
      	  [0,0,0,el[1],el[4],el[7]],
      	  [0,0,0,el[2],el[5],el[8]]];
};

// ʒuݒ肷
Body.prototype.setInitPosition=function(){
  this.p0.copy(this.p);
};

// ʒuԂɖ߂
Body.prototype.initPosition=function(){
  this.p.copy(this.p0);
};

// ׏dxNgԂ
// f - O
// t - OgN
// p - ʒu
Body.prototype.forceVector=function(f,t,p){
  var jw=mulmv3(tilde(p.w),this.inertia,p.w);
  return [f.x,f.y,f.z,t.x-jw.x,t.y-jw.y,t.z-jw.z];
};

//--------------------------------------------------------------------//
// p
// label - f[^x
// a - x
// b - y
// c - z
// density - x
var Box=function(label,a,b,c,density){
  Body.call(this,label);
  this.geometry=new THREE.BoxGeometry(a,b,c);
  this.density=density;
  this.mass=density*a*b*c;
  var ic=this.mass/12;
  this.inertia.set(ic*(b*b+c*c),0,0,
      	      	   0,ic*(c*c+a*a),0,
      	      	   0,0,ic*(a*a+b*b));
};

// ̖Ԃ
Box.prototype.getName=function(){
  return 'Box'+this.label;
};

//--------------------------------------------------------------------//
// 
// label f[^x
// ro - Oa
// ri - a
// density - x
var Sphere=function(label,ro,ri,density){
  Body.call(this,label);
  this.geometry=new THREE.SphereGeometry(ro);
  this.ri=ri;
  this.density=density;
  var ro3=ro*ro*ro,ri3=ri*ri*ri,mc=4*Math.PI*density/3;
  this.mass=mc*(ro3-ri3);
  var ix=0.4*mc*(ro3*ro*ro-ri3*ri*ri);
  this.inertia.set(ix,0,0,0,ix,0,0,0,ix);
};

// ̖Ԃ
Sphere.prototype.getName=function(){
  return 'Sphere'+this.label;
};

//--------------------------------------------------------------------//
// ~
// label f[^x
// ro - Oa
// ri - a
// l - 
// density - x
var Cylinder=function(label,ro,ri,l,density){
  Body.call(this,label);
  this.geometry=new THREE.CylinderGeometry(ro,ro,l);
  this.geometry.rotateX(0.5*Math.PI);
  this.ri=ri;
  this.density=density;
  this.mass=Math.PI*density*(ro*ro-ri*ri)*l;
  var ix=this.mass*(3*(ro*ro+ri*ri)+l*l)/12;
  this.inertia.set(ix,0,0,0,ix,0,0,
      	      	   0,0.5*this.mass*(ro*ro+ri*ri));
};

// ̖Ԃ
Cylinder.prototype.getName=function(){
  return 'Cylinder'+this.label;
};

inherits(Box,Body);
inherits(Sphere,Body);
inherits(Cylinder,Body);
