//--------------------------------------------------------------------//
// S
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var Constraint=function(p1,p2,r1,r2){
  this.p1=p1;
  this.p2=p2;
  this.r1=r1;
  this.r2=r2;
  this.vector=[];
};

// SΏۈʒuݒ肷
// p1,p2 - SΏۈʒũCfbNX
Constraint.prototype.setPosition=function(p1,p2){
  this.p1=p1;
  this.p2=p2;
};

// Sʒuݒ肷
// r1,r2 - SΏە̂̍Sʒu
Constraint.prototype.setCoords=function(r1,r2){
  this.r1=r1;
  this.r2=r2;
};

// SΏە̂PƂQւ
Constraint.prototype.swap=function(){
  var tp=this.p1;
  this.p1=this.p2;
  this.p2=tp;
  var tr=this.r1;
  this.r1=this.r2;
  this.r2=tr;
};

//--------------------------------------------------------------------//
// S
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var RigidConstraint=function(p1,p2,r1,r2){
  Constraint.call(this,p1,p2,r1,r2);
  this.alpha=10;
  this.beta=10;
  this.matrix=[null,null];
};

// oEKë艻p[^ݒ肷
// alpha,beta - oEKë艻p[^,
RigidConstraint.prototype.setBaumgarte=function(alpha,beta){
  this.alpha=alpha;
  this.beta=beta;
};

// dSʒuExݒ肷
// p1,p2 - SΏۈʒu
RigidConstraint.prototype.setGcPosition=function(p1,p2){
  if(p1===null){
    p2.setGcPosition(this.r2,this.r1,new THREE.Vector3());
  }
  else if(p2===null){
    p1.setGcPosition(this.r1,this.r2,new THREE.Vector3());
  }
  else{
    p2.setGcPosition(this.r2,p1.vector(this.r1),p1.velVector(this.r1));
  }
};

// _S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// index - S̊Jns
RigidConstraint.prototype.point=function(p1,p2,index){
  var g1=this.point2(p1,this.r1,index,0);
  var bt2=this.beta*this.beta;
  if(g1===null){
    this.vector[index]+=bt2*this.r1.x;
    this.vector[index+1]+=bt2*this.r1.y;
    this.vector[index+2]+=bt2*this.r1.z;
  }
  else{
    this.vector[index]-=g1.x;
    this.vector[index+1]-=g1.y;
    this.vector[index+2]-=g1.z;
  }
  var g2=this.point2(p2,this.r2,index,1);
  if(g2===null){
    this.vector[index]-=bt2*this.r2.x;
    this.vector[index+1]-=bt2*this.r2.y;
    this.vector[index+2]-=bt2*this.r2.z;
  }
  else{
    this.vector[index]+=g2.x;
    this.vector[index+1]+=g2.y;
    this.vector[index+2]+=g2.z;
  }
};

// _S}gbNXES׏dxNg쐬
// p - SΏۈʒu
// r - Sʒu
// index - S̊Jns
// mi - ̂̃CfbNX
RigidConstraint.prototype.point2=function(p,r,index,mi){
  if((p===null) || (r===null)) return null;
  var rr=conversionMatrix(p.p);
  var rtl=tilde(r);
  var cth=mul2(rr,rtl).multiplyScalar(-1);
  var cf=Number(2*mi-1);
  var mat=this.matrix[mi];
  var cthe=cth.elements;
  for(var i=0;i<3;i++){
    mat[index+i][i]=cf;
    for(var j=0;j<3;j++){
      mat[index+i][3+j]=cf*cthe[i+3*j];
    }
  }
  var gam=mulmv3(tilde(p.w),rtl,p.w).applyMatrix3(rr);
  var v1=new THREE.Vector3().addVectors(p.v,mulmv2(cth,p.w))
      	.multiplyScalar(2*this.alpha);
  var v2=p.vector(r).multiplyScalar(this.beta*this.beta);
  return gam.sub(v1.add(v2));
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// s1,s2 - SΏە̂̈ړ
// index - S̊Jns
RigidConstraint.prototype.axis=function(p1,p2,s1,s2,index){
  var rr1,rr2,w1,w2;
  if(p1===null){
    rr1=new THREE.Matrix3();
    w1=new THREE.Vector3();
  }
  else{
    rr1=conversionMatrix(p1.p);
    w1=p1.w;
  }
  if(p2===null){
    rr2=new THREE.Matrix3();
    w2=new THREE.Vector3();
  }
  else{
    rr2=conversionMatrix(p2.p);
    w2=p2.w;
  }
  var stl1=tilde(s1);
  var stl2=tilde(s2);
  var wtl1=tilde(w1);
  var wtl2=tilde(w2);
  var rrstl1=mul2(rr1,stl1);
  var rrstl2=mul2(rr2,stl2);
  var rr12=mult(rr1,rr2);
  var rr21=rr12.clone().transpose();

  var cth1=mul2(rrstl2,mult(rr2,rrstl1));
  var cth2=mul2(rrstl1,mult(rr1,rrstl2)).multiplyScalar(-1);
  var a1=add(mul2(tilde(mulmv2(wtl2,s2)),rr21),mul3(stl2,rr21,wtl1));
  a1=mul3(rr2,a1,stl1).multiplyScalar(-1);
  var a2=add(mul2(tilde(mulmv2(wtl1,s1)),rr12),mul3(stl1,rr12,wtl2));
  a2=mul3(rr1,a2,stl2);
  var gam=mulmv2(a1,w1).add(mulmv2(a2,w2));
  var v1=mulmv2(cth1,w1).add(mulmv2(cth2,w2))
      	.multiplyScalar(2*this.alpha);
  var v2=mulmv3(rrstl1,rr12,s2).multiplyScalar(this.beta*this.beta);
  gam.sub(v1.add(v2));

  var clist=compList(mulmv2(rr1,s1)),gg=[gam.x,gam.y,gam.z];
  var cthe1=cth1.elements,cthe2=cth2.elements;
  for(var i=0;i<2;i++){
    for(var j=0;j<3;j++){
      this.matrix[0][index+i][j+3]=cthe1[clist[i]+3*j];
      this.matrix[1][index+i][j+3]=cthe2[clist[i]+3*j];
    }
    this.vector[index+i]=gg[clist[i]];
  }
};

// ΈʒuS}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// s - SΏە̂̈ړ
// index - S̊Jns
RigidConstraint.prototype.direction=function(p1,p2,s,index){
  var rr1,rr2,x1,x2,v1,v2,w1,w2;
  if(p1===null){
    rr1=new THREE.Matrix3();
    x1=this.r1.clone();
    v1=new THREE.Vector3();
    w1=new THREE.Vector3();
  }
  else{
    rr1=conversionMatrix(p1.p);
    x1=p1.vector(this.r1);
    v1=p1.v;
    w1=p1.w;
  }
  if(p2===null){
    rr2=new THREE.Matrix3();
    x2=this.r2.clone();
    v2=new THREE.Vector3();
    w2=new THREE.Vector3();
  }
  else{
    rr2=conversionMatrix(p2.p);
    x2=p2.vector(this.r2);
    v2=p2.v;
    w2=p2.w;
  }
  var stl=tilde(s);
  var rtl1=tilde(this.r1);
  var rtl2=tilde(this.r2);
  var wtl1=tilde(w1);
  var wtl2=tilde(w2);
  var rrstl=mul2(rr1,stl);
  var rtr=mul2(rrstl,rr1.clone().transpose());
  var rrwtl1=mul2(rr1,wtl1);

  var d12=x2.sub(x1);
  var cr1=rtr.clone().multiplyScalar(-1);
  var cr2=rtr;
  var cth1=add(mul2(rrstl,rtl1),mul2(tilde(d12),rrstl));
  var cth2=mul3(rtr,rr2,rtl2).multiplyScalar(-1);
  var gam=tilde(v1.clone().sub(v2).multiplyScalar(2));
  gam=mulmv3(gam,rrstl,w1);
  var vv1=mulmv3(rr2,wtl2,this.r2).sub(mulmv2(rrwtl1,this.r1));
  var a1=add(add(mul3(rrwtl1,stl,rtl1),mul2(tilde(vv1),rrstl)),
      	     mul3(tilde(d12),rrwtl1,stl)).multiplyScalar(-1);
  var rr12=mult(rr1,rr2);
  var a2=mul3(rr1,add(mul2(tilde(mulmv2(wtl1,s)),rr12),
      	      	      mul3(stl,rr12,wtl2)),rtl2);
  var v12=mulmv2(a1,w1).add(mulmv2(a2,w2));
  vv1=mulmv2(cr1,v1).add(mulmv2(cr2,v2)).add(mulmv2(cth1,w1))
    .add(mulmv2(cth2,w2)).multiplyScalar(2*this.alpha);
  var vv2=mulmv2(rtr,d12).multiplyScalar(this.beta*this.beta);
  gam.add(v12).sub(vv1.add(vv2));

  var clist=compList(mulmv2(rr1,s)),gg=[gam.x,gam.y,gam.z];
  var cre1=cr1.elements,cre2=cr2.elements;
  var cthe1=cth1.elements,cthe2=cth2.elements;
  for(var i=0;i<2;i++){
    var mat1=this.matrix[0][index+i];
    var mat2=this.matrix[1][index+i];
    for(var j=0;j<3;j++){
      var cl=clist[i]+3*j;
      mat1[j]=cre1[cl];
      mat1[j+3]=cthe1[cl];
      mat2[j]=cre2[cl];
      mat2[j+3]=cthe2[cl];
    }
    this.vector[index+i]=gg[clist[i]];
  }
};

// ]S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
// b1x,b2y - SΏە̂̈ړ
// index - S̊Jns
RigidConstraint.prototype.rotate=function(p1,p2,b1x,b2y,index){
  var rr1,rr2,w1,w2;
  if(p1===null){
    rr1=new THREE.Matrix3();
    w1=new THREE.Vector3();
  }
  else{
    rr1=conversionMatrix(p1.p);
    w1=p1.w;
  }
  if(p2===null){
    rr2=new THREE.Matrix3();
    w2=new THREE.Vector3();
  }
  else{
    rr2=conversionMatrix(p2.p);
    w2=p2.w;
  }

  var wtl1=tilde(w1);
  var wtl2=tilde(w2);
  var rr21=mult(rr2,rr1);
  var cth1=mulmv3(tilde(b1x),rr21.clone().transpose(),b2y);
  var cth2=mulmv3(tilde(b2y),rr21,b1x);

  var ga1=add(mul3(rr21,wtl1,wtl1),mul3(wtl2,wtl2,rr21));
  var ga2=mul3(tilde(b2y),rr21,tilde(b1x));
  var gam1=mulmv2(ga1,b1x).dot(b2y);
  var gam2=mulmv2(ga2,w1).dot(w2);
  var gam3=cth1.dot(w1)+cth2.dot(w2);
  var gam4=mulmv2(rr21,b1x).dot(b2y);
  var gam=-gam1+2*gam2-2*this.alpha*gam3-this.beta*this.beta*gam4;
  var mat1=this.matrix[0][index];
  var mat2=this.matrix[1][index];
  mat1[3]=cth1.x;
  mat1[4]=cth1.y;
  mat1[5]=cth1.z;
  mat2[3]=cth2.x;
  mat2[4]=cth2.y;
  mat2[5]=cth2.z;
  this.vector[index]=gam;
};

// xNg̐Ԃ̃XgA
// v - xNg
function compList(v){
  var index=[0,1,2],vv=[Math.abs(v.x),Math.abs(v.y),Math.abs(v.z)],tv;
  if(vv[0]>vv[1]){
    tv=vv[1];
    vv[1]=vv[0];
    vv[0]=tv;
    index[0]=1;
    index[1]=0;
  }
  if(vv[0]>vv[2]){
    tv=vv[2];
    vv[2]=vv[1];
    vv[1]=vv[0];
    vv[0]=tv;
    index[2]=index[1];
    index[1]=index[0];
    index[0]=2;
  }
  else if(vv[1]>vv[2]){
    tv=vv[2];
    vv[2]=vv[1];
    vv[1]=tv;
    index[2]=index[1];
    index[1]=2;
  }
  return index;
}

//--------------------------------------------------------------------//
// WCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var BallJoint=function(p1,p2,r1,r2){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.dof=3;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
BallJoint.prototype.create=function(p1,p2){
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  if(p1!==null) this.matrix[0]=numeric.rep([this.dof,6],0);
  if(p2!==null) this.matrix[1]=numeric.rep([this.dof,6],0);
  this.point(p1,p2,0);
};

//--------------------------------------------------------------------//
// jo[TWCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var UniversalJoint=function(p1,p2,r1,r2){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.dof=4;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.b1x=new THREE.Vector3(1,0,0);
  this.b2y=new THREE.Vector3(0,1,0);
};

// SΏە̂̎ݒ肷
// b1x,b2y - SΏە̂̉]
UniversalJoint.prototype.setAxis=function(b1x,b2y){
  this.b1x=b1x;
  this.b2y=b2y;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
UniversalJoint.prototype.create=function(p1,p2){
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.point(p1,p2,0);
  this.rotate(p1,p2,this.b1x,this.b2y,3);
};

//--------------------------------------------------------------------//
// ]WCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
var RotateJoint=function(p1,p2,r1,r2){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.dof=5;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.s1=new THREE.Vector3(0,0,1);
  this.s2=new THREE.Vector3(0,0,1);
};

// SΏە̂̎ݒ肷
// s1,s2 - SΏە̂̈ړ
RotateJoint.prototype.setAxis=function(s1,s2){
  this.s1=s1;
  this.s2=s2;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
RotateJoint.prototype.create=function(p1,p2){
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.point(p1,p2,0);
  this.axis(p1,p2,this.s1,this.s2,3);
};

//--------------------------------------------------------------------//
// ]~WCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
// z0 - ʒu
var CylinderJoint=function(p1,p2,r1,r2,z0){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.z0=z0;
  this.dof=4;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.s1=new THREE.Vector3(0,0,1);
  this.s2=new THREE.Vector3(0,0,1);
};

// SΏە̂̎ݒ肷
// s1,s2 - SΏە̂̈ړ
CylinderJoint.prototype.setAxis=function(s1,s2){
  this.s1=s1;
  this.s2=s2;
};

// dSʒuExݒ肷
// p1,p2 - SΏۈʒu
CylinderJoint.prototype.setGcPosition=function(p1,p2){
  if(p1===null){
    p2.setGcPosition(this.r2,this.r1,new THREE.Vector3());
  }
  else if(p2===null){
    p1.setGcPosition(this.r1,this.r2,new THREE.Vector3());
  }
  else{
    var ri=this.r1.clone().addScaledVector(this.s1,this.z0);
    p2.setGcPosition(this.r2,p1.vector(ri),p1.velVector(ri));
  }
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
CylinderJoint.prototype.create=function(p1,p2){
  this.axis(p1,p2,this.s1,this.s2,0);
  this.direction(p1,p2,this.s1,2);
};

//--------------------------------------------------------------------//
// ]iWCg
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
// z0 - ʒu
var Slider=function(p1,p2,r1,r2,z0){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.z0=z0;
  this.dof=5;
  for(var i=0;i<this.dof;i++) this.vector[i]=0;
  this.matrix[0]=numeric.rep([this.dof,6],0);
  this.matrix[1]=numeric.rep([this.dof,6],0);
  this.s1=new THREE.Vector3(0,0,1);
  this.s2=new THREE.Vector3(0,0,1);
  this.b1x=new THREE.Vector3(1,0,0);
  this.b2x=new THREE.Vector3(1,0,0);
};

// SΏە̂̎ݒ肷
// s1,s2 - SΏە̂̈ړ
// b1x,b2x - SΏە̂̈ړ
Slider.prototype.setAxis=function(s1,s2,b1x,b2x){
  this.s1=s1;
  this.s2=s2;
  this.b1x=b1x;
  this.b2x=b2x;
};

// dSʒuExݒ肷
// p1,p2 - SΏۈʒu
Slider.prototype.setGcPosition=function(p1,p2){
  if(p1===null){
    p2.setGcPosition(this.r2,this.r1,new THREE.Vector3());
  }
  else if(p2===null){
    p1.setGcPosition(this.r1,this.r2,new THREE.Vector3());
  }
  else{
    var ri=this.r1.clone().addScaledVector(this.s1,this.z0);
    p2.setGcPosition(this.r2,p1.vector(ri),p1.velVector(ri));
  }
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
Slider.prototype.create=function(p1,p2){
  var b2y=this.s2.clone().cross(this.b2x).normalize();
  this.axis(p1,p2,this.s1,this.s2,0);
  this.direction(p1,p2,this.s1,2);
  this.rotate(p1,p2,this.b1x,b2y,4);
};

//--------------------------------------------------------------------//
// ΂˗vf
// p1,p2 - SΏۈʒũCfbNX
// r1,r2 - SΏە̂̍Sʒu
// k - ΂˒萔
// l0 - R
var Spring=function(p1,p2,r1,r2,k,l0){
  RigidConstraint.call(this,p1,p2,r1,r2);
  this.k=k;
  this.l0=l0;
  this.dof=3;
};

// S}gbNXES׏dxNg쐬
// p1,p2 - SΏۈʒu
Spring.prototype.create=function(p1,p2){
  var f;
  if(p2!==null) f=p2.vector(this.r2);
  else          f=this.r2.clone();
  if(p1!==null) f.sub(p1.vector(this.r1));
  else          f.sub(this.r1);
  var l=f.length();
  if(l!==0) f.multiplyScalar(this.k*(l-this.l0)/l);
  this.vector=[f.x,f.y,f.z,-f.x,-f.y,-f.z];
};

inherits(RigidConstraint,Constraint);
inherits(BallJoint,RigidConstraint);
inherits(UniversalJoint,RigidConstraint);
inherits(RotateJoint,RigidConstraint);
inherits(CylinderJoint,RigidConstraint);
inherits(Slider,RigidConstraint);
inherits(Spring,Constraint);
