var C1=[1.0/6.0,1.0/3.0,1.0/3.0,1.0/6.0];	// Runge - Kutta@̌W1
var C2=[0.5,0.5,1.0];				// Runge - Kutta@̌W2

//--------------------------------------------------------------------//
// ̌nf[^f
var MbdDataModel=function(){
  this.bodies=[];		// ̃Xg
  this.rigids=[];		// SXg
  this.springs=[];		// _SXg
  this.tempPos=[];		// Runge-Kutta@Xebṽf[^
  this.g=new THREE.Vector3(0,0,-9.80665);	// d͉xxNg
  this.matrix=[];		// ʁES}gbNX
  this.vector=[];		// ׏dxNg
  this.size=0;			// }gbNXExNg̃TCY
};

// f[^
MbdDataModel.prototype.clear=function(){
  this.bodies.length=0;
  this.rigids.length=0;
  this.springs.length=0;
  this.tempPos.length=0;
  this.matrix.length=0;
  this.vector.length=0;
  this.size=0;
};

// oEKë艻p[^ݒ肷
// alpha,beta - oEKë艻p[^,
MbdDataModel.prototype.setBaumgarte=function(alpha,beta){
  for(var i=0;i<this.rigids.length;i++){
    this.rigids[i].setBaumgarte(alpha,beta);
  }
};

// f
MbdDataModel.prototype.init=function(){
  this.bodies.sort(function(b1,b2){
    if(b1.label<b2.label)      return -1;
    else if(b1.label>b2.label) return 1;
    else                       return 0;
  });
  this.reNumbering();
  this.rigids.sort(compareConstraints);
  this.springs.sort(compareConstraints);
  this.setSize();
  this.setTempPosition1();
  this.setGcPosition();
  this.setInitPosition();
  this.setGravity();
};

// ߓ_|C^ݒ肷
MbdDataModel.prototype.reNumbering=function(){
  var labelMap=[],p1,p2;	// javascript̔z̎̂͘Azz
  for(var i=0;i<this.bodies.length;i++){
    labelMap[this.bodies[i].label]=i;
  }
  for(i=0;i<this.rigids.length;i++){
    p1=this.rigids[i].p1;
    p2=this.rigids[i].p2;
    if(p1 in labelMap) p1=labelMap[p1];
    if(p2 in labelMap) p2=labelMap[p2];
    this.rigids[i].setPosition(p1,p2);
  }
  for(i=0;i<this.springs.length;i++){
    p1=this.springs[i].p1;
    p2=this.springs[i].p2;
    if(p1 in labelMap) p1=labelMap[p1];
    if(p2 in labelMap) p2=labelMap[p2];
    this.springs[i].setPosition(p1,p2);
  }
};

// }gbNXExNg̃TCYݒ肷
MbdDataModel.prototype.setSize=function(){
  this.size=6*this.bodies.length;
  for(var i=0;i<this.rigids.length;i++){
    this.size+=this.rigids[i].dof;
  }
  this.matrix=numeric.rep([this.size,this.size],0.0);
  this.vector=numeric.rep([this.size],0.0);
};

// Runge-Kutta@Xebṽf[^ݒ肷
MbdDataModel.prototype.setTempPosition1=function(){
  for(var i=0;i<this.bodies.length;i++){
    this.tempPos[i]=[this.bodies[i].p,null,null,null];
  }
};

// dSʒuExݒ肷
MbdDataModel.prototype.setGcPosition=function(){
  for(var i=0;i<this.rigids.length;i++){
    var rigid=this.rigids[i];
    rigid.setGcPosition(this.getPosition(rigid.p1,0),
      	      	      	this.getPosition(rigid.p2,0));
  }
};

// ʒuݒ肷
MbdDataModel.prototype.setInitPosition=function(){
  for(var i=0;i<this.bodies.length;i++){
    this.bodies[i].setInitPosition();
  }
};

// ̂ɉd͂vZ
MbdDataModel.prototype.setGravity=function(){
  for(var i=0;i<this.bodies.length;i++){
    var mass=this.bodies[i].mass;
    this.bodies[i].mg.set(mass*this.g.x,mass*this.g.y,mass*this.g.z);
  }
};

// ʒuԂɖ߂
MbdDataModel.prototype.initPosition=function(){
  time=0;
  step=0;
  for(var i=0;i<this.bodies.length;i++){
    this.bodies[i].initPosition();
  }
  this.setTempPosition1();
  this.setGcPosition();
};

// ̃XebvvZ
MbdDataModel.prototype.next=function(){
  time+=dt;
  step++;
  for(var i=0;i<4;i++){
    this.setTempPosition2(i);
    this.createMatrixVector(i);
// asLUP͔ΉiΊpvfOɂȂ蓾j
    this.setAcc(numeric.solve(this.matrix,this.vector),i);
  }
  this.update();
};

// Runge-Kutta@Xebṽf[^ݒ肷
// dt - ԍݕ
// step - Runge-Kutta@̃Xebv
MbdDataModel.prototype.setTempPosition2=function(step){
  if(step===0) return;
  var cdt=dt*C2[step-1];
  for(var i=0;i<this.bodies.length;i++){
    var tp=this.tempPos[i],pre=tp[step-1];
    tp[step]=this.bodies[i].p.clone();
    tp[step].update2(cdt,pre.v,pre.a,pre.eulerVel(),pre.dw);
  }
};

// ʁES}gbNXщ׏dxNg쐬
// step - Runge-Kutta@̃Xebv
MbdDataModel.prototype.createMatrixVector=function(step){
  var ii=0,i1,j1,j0,dof,m,f,mati,mi;
  for(var i=0;i<this.size;i++){
    mati=this.matrix[i];
    for(var j=0;j<this.size;j++){
      mati[j]=0;
    }
    this.vector[i]=0;
  }
  for(i=0;i<this.bodies.length;i++){
    var body=this.bodies[i];
    m=body.massMatrix();
    f=body.forceVector(body.mg,new THREE.Vector3(),
      	      	       this.getPosition(i,step));
    for(i1=0;i1<6;i1++){
      mati=this.matrix[ii+i1];
      mi=m[i1];
      for(j1=0;j1<6;j1++){
      	mati[ii+j1]=mi[j1];
      }
      this.vector[ii+i1]=f[i1];
    }
    ii+=6;
  }
  for(i=0;i<this.rigids.length;i++){
    var rigid=this.rigids[i];
    dof=rigid.dof;
    rigid.create(this.getPosition(rigid.p1,step),
      	      	 this.getPosition(rigid.p2,step));
    f=rigid.vector;
    if(rigid.p1>=0){
      m=rigid.matrix[0];
      j0=6*rigid.p1;
      for(i1=0;i1<dof;i1++){
      	mati=this.matrix[ii+i1];
      	mi=m[i1];
      	for(j1=0;j1<6;j1++){
      	  mati[j0+j1]=mi[j1];
      	  this.matrix[j0+j1][ii+i1]=mi[j1];
      	}
      }
    }
    if(rigid.p2>=0){
      m=rigid.matrix[1];
      j0=6*rigid.p2;
      for(i1=0;i1<dof;i1++){
      	mati=this.matrix[ii+i1];
      	mi=m[i1];
      	for(j1=0;j1<6;j1++){
      	  mati[j0+j1]=mi[j1];
      	  this.matrix[j0+j1][ii+i1]=mi[j1];
      	}
      }
    }
    for(i1=0;i1<dof;i1++){
      this.vector[ii+i1]=f[i1];
    }
    ii+=dof;
  }
  for(i=0;i<this.springs.length;i++){
    var spring=this.springs[i];
    dof=spring.dof;
    spring.create(this.getPosition(spring.p1,step),
      	      	  this.getPosition(spring.p2,step));
    f=spring.vector;
    if(spring.p1>=0){
      j0=6*spring.p1;
      for(i1=0;i1<dof;i1++){
      	this.vector[j0+i1]+=f[i1];
      }
    }
    if(spring.p2>=0){
      j0=6*spring.p2;
      for(i1=0;i1<dof;i1++){
      	this.vector[j0+i1]+=f[dof+i1];
      }
    }
  }
};

// xݒ肷
// a - xxNg
// step - Runge - Kutta@̃Xebv
MbdDataModel.prototype.setAcc=function(a,step){
  var ii=0;
  for(var i=0;i<this.bodies.length;i++){
    this.tempPos[i][step].setAcc(a,ii);
    ii+=6;
  }
};

// f[^XV
// dt - ԍݕ
MbdDataModel.prototype.update=function(){
  var dx=new THREE.Vector3();
  var dv=new THREE.Vector3();
  var dp=[0,0,0,0];
  var dw=new THREE.Vector3();
  var cdt=[dt*C1[0],dt*C1[1],dt*C1[2],dt*C1[3]];
  for(var i=0;i<this.bodies.length;i++){
    dx.set(0,0,0);
    dv.set(0,0,0);
    for(var j=0;j<4;j++) dp[j]=0;
    dw.set(0,0,0);
    for(j=0;j<4;j++){
      var tp=this.tempPos[i][j];
      dx.addScaledVector(tp.v,cdt[j]);
      dv.addScaledVector(tp.a,cdt[j]);
      var ddp=tp.eulerVel();
      for(var k=0;k<4;k++) dp[k]+=0.5*cdt[j]*ddp[k];
      dw.addScaledVector(tp.dw,cdt[j]);
    }
    this.bodies[i].p.update1(dx,dv,dp,dw);
  }
};

// ̈ʒuԂ
// index - ̂̃CfbNX
// step - Runge-Kutta@̃Xebv
MbdDataModel.prototype.getPosition=function(index,step){
  if(index<0) return null;
  else        return this.tempPos[index][step];
};

// S̔r
// c1,c2 - rS
function compareConstraints(c1,c2){
  if(c1.p1<c2.p1)      return -1;
  else if(c1.p1>c2.p1) return 1;
  else if(c1.p2<c2.p2) return -1;
  else if(c1.p2>c2.p2) return 1;
  else                 return 0;
}
