//--------------------------------------------------------------------//
// }`{fB_Ci~NX

var model;		// ̌nf[^f
var viewModel;		// \f
var bounds;		// fE
var timeView;		// ԕ\
var time,dt;		// Eԍݕ
var step;		// ^CXebv
var running;		// vZsXCb`
var viewConfig;		// f\ݒ
var modalWindow;	// [_EBhE
var material;		// f\}eA

var FILE_WINDOW=0;	// t@CEBhE
var CONFIG_WINDOW=1;	// RtBOEBhE

// f[^
// fileName - f[^t@C
function initModel(fileName){
  model=new MbdDataModel();
  time=0;
  dt=1;
  step=0;
  running=false;
  document.addEventListener('keydown',keyPressed,false);
  bounds=new Bounds();
  initThree();
  viewConfig=new ViewConfig();
  if((fileName!==null) && (fileName!==undefined)){
    readServerFile(fileName);
  }
  modalWindow=[document.getElementById('file'),
      	       document.getElementById('config')];
  loop();
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 65:		// A
    case 88:		// X
    case 96:		// Numpad0 On
      viewModel.viewX();
      break;
    case 89:		// Y
      viewModel.viewY();
      break;
    case 90:		// Z
      viewModel.viewZ();
      break;
  }
}

// three.js ̏
function initThree(){
  viewModel=new ViewModel('mbd-canvas');
  timeView=document.getElementById('time-canvas');
  timeView.style.color='#ffffff';
  timeView.style.backgroundColor='#000000';
  showTime();
  material=new THREE.MeshStandardMaterial
    ({color:0xcacccc,roughness:0.3,metalness:0.4});
}

// \IuWFNg
function initObject(){
  if(model.bodies.length===0) return;
  for(var i=0;i<model.bodies.length;i++){
    model.bodies[i].setMesh(material);
  }
  bounds.set();
  for(i=0;i<model.bodies.length;i++){
    viewModel.addObject(model.bodies[i].mesh);
  }
  viewModel.setAxis();
  viewModel.updateLightAndCamera();
}

// \IuWFNg
function removeObjects(){
  for(var i=0;i<model.bodies.length;i++){
    var body=model.bodies[i],mesh=body.mesh;
    viewModel.removeObject(mesh);
    mesh.geometry.dispose();
    mesh.material.dispose();
    body.mesh=null;
  }
}

// [v֐
function loop(){
  viewModel.update();
  if(running){
    showTime();
    model.next();
    updateObject();
  }
  requestAnimationFrame(loop);
}

// \
function showTime(){
  timeView.textContent='Time = '+numString(time);
}

// \IuWFNgXV
function updateObject(){
  for(var i=0;i<model.bodies.length;i++){
    model.bodies[i].setMeshPosition();
  }
}

// vZJn
function calcStart(){
  running=true;
}

// vZ𒆒f
function calcStop(){
  running=false;
}

// vZԂɖ߂
function calcInit(){
  running=false;
  model.initPosition();
  updateObject();
  showTime();
}

// f[^Ԃ
// body - Ώە
// te - I
function timeHistory(body,te){
  var s=[];
  model.initPosition();
  s.push('time\tx\ty\tz\tp0\tp1\tp2\tp3');
  while(time<te){
    model.next();
    s.push(time+'\t'+body.p.toString());
  }
  model.initPosition();
  updateObject();
  showTime();
  return s;
}

// `_}gbNXԂ
// p - 3xNg
function tilde(p){
  return new THREE.Matrix3().set(0,-p.z,p.y,p.z,0,-p.x,
      	      	      	      	 -p.y,p.x,0);
}

// WϊsԂ
// p - IC[p[^iNH[^jIj
function conversionMatrix(p){
  var pww=p.w*p.w;
  return new THREE.Matrix3().set(2*(pww+p.x*p.x)-1,
      	      	      	      	 2*(p.x*p.y-p.w*p.z),
      	      	      	      	 2*(p.x*p.z+p.w*p.y),
      	      	      	      	 2*(p.x*p.y+p.w*p.z),
      	      	      	      	 2*(pww+p.y*p.y)-1,
      	      	      	      	 2*(p.y*p.z-p.w*p.x),
      	      	      	      	 2*(p.x*p.z-p.w*p.y),
      	      	      	      	 2*(p.y*p.z+p.w*p.x),
      	      	      	      	 2*(pww+p.z*p.z)-1);
}

// IC[p[^̕s E Ԃ
// p - IC[p[^iNH[^jIj
function matrixE(p){
  return [[-p.x,p.w,-p.z,p.y],
      	  [-p.y,p.z,p.w,-p.x],
      	  [-p.z,-p.y,p.x,p.w]];
}

// IC[p[^̕s L Ԃ
// p - IC[p[^iNH[^jIj
function matrixL(p){
  return [[-p.x,p.w,p.z,-p.y],
      	  [-p.y,-p.z,p.w,p.x],
      	  [-p.z,p.y,-p.x,p.w]];
}

// Matrix3̘aԂ
// m1,m2 - s
function add(m1,m2){
  var e1=m1.elements;
  var e2=m2.elements;
  return new THREE.Matrix3().set(e1[0]+e2[0],e1[3]+e2[3],e1[6]+e2[6],
      	      	      	      	 e1[1]+e2[1],e1[4]+e2[4],e1[7]+e2[7],
      	      	      	      	 e1[2]+e2[2],e1[5]+e2[5],e1[8]+e2[8]);
}

// Matrix3̐ςԂ
// m1,m2 - |킹s
function mul2(m1,m2){
  var e1=m1.elements;
  var e2=m2.elements;
  return new THREE.Matrix3().set(e1[0]*e2[0]+e1[3]*e2[1]+e1[6]*e2[2],
      	      	      	      	 e1[0]*e2[3]+e1[3]*e2[4]+e1[6]*e2[5],
      	      	      	      	 e1[0]*e2[6]+e1[3]*e2[7]+e1[6]*e2[8],
      	      	      	      	 e1[1]*e2[0]+e1[4]*e2[1]+e1[7]*e2[2],
      	      	      	      	 e1[1]*e2[3]+e1[4]*e2[4]+e1[7]*e2[5],
      	      	      	      	 e1[1]*e2[6]+e1[4]*e2[7]+e1[7]*e2[8],
      	      	      	      	 e1[2]*e2[0]+e1[5]*e2[1]+e1[8]*e2[2],
      	      	      	      	 e1[2]*e2[3]+e1[5]*e2[4]+e1[8]*e2[5],
      	      	      	      	 e1[2]*e2[6]+e1[5]*e2[7]+e1[8]*e2[8]);
}

// Matrix3̐ςԂ
// m1,m2,m3 - |킹s
function mul3(m1,m2,m3){
  return mul2(m1,mul2(m2,m3));
}

// ]usƍs̐ m1Tm2 Ԃ
// m1 - ]uĊ|킹s
// m2 - |킹s
function mult(m1,m2){
  var e1=m1.elements;
  var e2=m2.elements;
  return new THREE.Matrix3().set(e1[0]*e2[0]+e1[1]*e2[1]+e1[2]*e2[2],
      	      	      	      	 e1[0]*e2[3]+e1[1]*e2[4]+e1[2]*e2[5],
      	      	      	      	 e1[0]*e2[6]+e1[1]*e2[7]+e1[2]*e2[8],
      	      	      	      	 e1[3]*e2[0]+e1[4]*e2[1]+e1[5]*e2[2],
      	      	      	      	 e1[3]*e2[3]+e1[4]*e2[4]+e1[5]*e2[5],
      	      	      	      	 e1[3]*e2[6]+e1[4]*e2[7]+e1[5]*e2[8],
      	      	      	      	 e1[6]*e2[0]+e1[7]*e2[1]+e1[8]*e2[2],
      	      	      	      	 e1[6]*e2[3]+e1[7]*e2[4]+e1[8]*e2[5],
      	      	      	      	 e1[6]*e2[6]+e1[7]*e2[7]+e1[8]*e2[8]);
}

// sƃxNg̐AbԂ
// a,b - sA,xNgb
function mulmv2(a,b){
  return b.clone().applyMatrix3(a);
}

// sƃxNg̐A1A2bԂ
// a1,a2,b - sA1,A2,xNgb
function mulmv3(a1,a2,b){
  return b.clone().applyMatrix3(a2).applyMatrix3(a1);
}

// l\Ԃ
// value - l
function numString(value){
  var vabs=Math.abs(value);
  if(vabs>=1.0E5){
    return value.toExponential(4);
  }
  else if((vabs>=1) || (vabs===0)){
    return value.toFixed(3);
  }
  else if(vabs>=0.01){
    return value.toFixed(4);
  }
  else{
    return value.toExponential(4);
  }
}

// [_EBhE\
// win - [_EBhẼCfbNX
function showModalWindow(win){
  modalWindow[win].style.zIndex=4;
  modalWindow[win].style.opacity=1;
}

// [_EBhE\ɂ
// win - [_EBhẼCfbNX
function hideModalWindow(win){
  modalWindow[win].style.zIndex=1;
  modalWindow[win].style.opacity=0;
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}
