//--------------------------------------------------------------------//
// \f
// canvasId - \̈ID
var ViewModel=function(canvasId){
  this.canvasFrame=document.getElementById(canvasId);		// `t[
  this.renderer=new THREE.WebGLRenderer({antialias:true});	// _\
  if(!this.renderer){
    alert("three.js ̏Ɏs܂");
  }

  this.renderer.setSize(this.canvasFrame.clientWidth,
      	      	      	this.canvasFrame.clientHeight);
  this.canvasFrame.appendChild(this.renderer.domElement);

  this.renderer.setClearColor(0x000000,1.0);
  this.scene=new THREE.Scene();					// V[
  this.initLight();
  this.initCamera();
  this.axis=null;
};

// 
ViewModel.prototype.initLight=function(){
// s
  this.directionalLight=new THREE.DirectionalLight(0xffffff,1.0);
  bounds.setLightPosition(this.directionalLight.position);
  this.scene.add(this.directionalLight);
// 
  this.ambientLight=new THREE.AmbientLight(0xcccccc);
  this.scene.add(this.ambientLight);
};

// J
ViewModel.prototype.initCamera=function(){
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size,c=bounds.center;
// J
  this.camera=new THREE.OrthographicCamera
    (-side*aspect,side*aspect,side,-side,
     0.01*bounds.size,100*bounds.size);
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
//  this.camera.lookAt({x:0,y:0,z:0});	Controlsgp͖

// gbN{[Rg[
  this.trackball=new THREE.OrthographicTrackballControls
      	      	   (this.camera,this.canvasFrame);
  this.trackball.screen.width=this.canvasFrame.clientWidth;
  this.trackball.screen.height=this.canvasFrame.clientHeight;
  var bdc=this.canvasFrame.getBoundingClientRect();
  this.trackball.screen.offetLeft=bdc.left;
  this.trackball.screen.offetTop=bdc.top;

  this.trackball.noRotate=false;
  this.trackball.rotateSpeed=4.0;
  this.trackball.noZoom=false;
  this.trackball.zoomSpeed=4.0;
  this.trackball.noPan=false;
  this.trackball.panSpeed=1.0;
  this.trackball.target.copy(c);
  this.trackball.staticMoving=true;
  this.trackball.dynamicDampingFactor=0.3;
};

// \IuWFNgǉ
ViewModel.prototype.addObject=function(obj){
  this.scene.add(obj);
};

// \IuWFNg폜
ViewModel.prototype.removeObject=function(obj){
  this.scene.remove(obj);
};

// Wݒ肷
ViewModel.prototype.setAxis=function(){
  if(this.axis!==null){
    this.scene.remove(this.axis);
    this.axis.geometry.dispose();
    this.axis.material.dispose();
  }
  this.axis=new THREE.AxisHelper(0.2*bounds.size);
  this.axis.position.set(0,0,0);
  this.scene.add(this.axis);
};

// EJʒuXV
ViewModel.prototype.updateLightAndCamera=function(){
  bounds.setLightPosition(this.directionalLight.position);
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size;
  this.camera.left=-side*aspect;
  this.camera.right=side*aspect;
  this.camera.top=side;
  this.camera.bottom=-side;
  this.camera.near=0.01*bounds.size;
  this.camera.far=100*bounds.size;
  this.viewZ();
};

// \XV
ViewModel.prototype.update=function(){
  this.trackball.update();
  this.renderer.render(this.scene,this.camera);
};

// _Xɂ
ViewModel.prototype.viewX=function(){
  var c=bounds.center;
  this.camera.position.set(c.x+bounds.viewPoint,c.y,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Yɂ
ViewModel.prototype.viewY=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y-bounds.viewPoint,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Zɂ
ViewModel.prototype.viewZ=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

//--------------------------------------------------------------------//
// fE
var Bounds=function(){
  this.box=new THREE.Box3();
  this.center=new THREE.Vector3();
  this.size=1;
  this.viewPoint=1;
};

// fEݒ肷
Bounds.prototype.set=function(){
  var group=new THREE.Group();
  for(var i=0;i<model.bodies.length;i++){
    group.add(model.bodies[i].mesh);
  }
  this.box.setFromObject(group);
  this.center.copy(this.box.getCenter());
  this.size=Math.max(this.box.max.x-this.box.min.x,
      	      	     this.box.max.y-this.box.min.y,
      	      	     this.box.max.z-this.box.min.z);
  this.viewPoint=2*this.size;
  for(i=0;i<model.bodies.length;i++){
    group.remove(model.bodies[i].mesh);
  }
};

// ʒuݒ肷
// p - ʒu
Bounds.prototype.setLightPosition=function(p){
  p.set(this.size,-this.size,this.size);
};
